searchData={"items":[{"type":"module","doc":"ExESDB is a wrapper around the khepri library. \n  Its intention is to provide an interface to khepri,\n  with a focus on event sourcing.","title":"ExESDB","ref":"ExESDB.html"},{"type":"module","doc":"Aggregates events from an event stream using tagged rules:\n  GIVEN: an Event of roughly this format:\n   %{\n    event_id: \"1234567890\",\n    event_type: \"user.birthday_celebrated:v1\",\n    stream_id: \"celebrate-user-birthday-john\",\n    version: 1,\n    data: %{\n      name: \"John\",\n      age: {:sum, 1},\n      venue: {:overwrite, \"New York\"}\n    },\n    timestamp: ~U[2022-01-01 12:00:00Z],\n    epoch: 1641013200,\n    metadata: %{\n      source_id: \"1234567890\"\n    }\n  }","title":"ExESDB.Aggregator","ref":"ExESDB.Aggregator.html"},{"type":"function","doc":"","title":"ExESDB.Aggregator.finalize_map/1","ref":"ExESDB.Aggregator.html#finalize_map/1"},{"type":"function","doc":"Folds a list of events into a single map.","title":"ExESDB.Aggregator.foldl/2","ref":"ExESDB.Aggregator.html#foldl/2"},{"type":"module","doc":"This module is used to start the ExESDB system.","title":"ExESDB.App","ref":"ExESDB.App.html"},{"type":"module","doc":"Supervisor for cluster coordination components.\n\nThis supervisor manages cluster-specific coordination components:\n- ClusterCoordinator: Handles coordination logic and split-brain prevention\n- NodeMonitor: Monitors node health and handles failures\n\nNote: StoreCluster is managed at the System level since it's mode-aware.","title":"ExESDB.ClusterSystem","ref":"ExESDB.ClusterSystem.html"},{"type":"function","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","title":"ExESDB.ClusterSystem.child_spec/1","ref":"ExESDB.ClusterSystem.html#child_spec/1"},{"type":"function","doc":"","title":"ExESDB.ClusterSystem.start_link/1","ref":"ExESDB.ClusterSystem.html#start_link/1"},{"type":"module","doc":"Provides tools for verifying consistency across ExESDB cluster stores.\n\nThis module leverages Khepri and Ra APIs to verify that stores are consistent\nacross cluster nodes, detect split-brain scenarios, and ensure data integrity.","title":"ExESDB.ConsistencyChecker","ref":"ExESDB.ConsistencyChecker.html"},{"type":"function","doc":"Checks Raft log consistency across cluster members.\nThis is a more intensive check that examines log indices and terms.","title":"ExESDB.ConsistencyChecker.check_raft_log_consistency/1","ref":"ExESDB.ConsistencyChecker.html#check_raft_log_consistency/1"},{"type":"type","doc":"","title":"ExESDB.ConsistencyChecker.check_result/0","ref":"ExESDB.ConsistencyChecker.html#t:check_result/0"},{"type":"type","doc":"","title":"ExESDB.ConsistencyChecker.consistency_result/0","ref":"ExESDB.ConsistencyChecker.html#t:consistency_result/0"},{"type":"type","doc":"","title":"ExESDB.ConsistencyChecker.node_name/0","ref":"ExESDB.ConsistencyChecker.html#t:node_name/0"},{"type":"function","doc":"Quick health check to verify if a store is accessible and responsive across nodes.","title":"ExESDB.ConsistencyChecker.quick_health_check/1","ref":"ExESDB.ConsistencyChecker.html#quick_health_check/1"},{"type":"function","doc":"Monitors consistency over time and reports any deviations.","title":"ExESDB.ConsistencyChecker.start_consistency_monitoring/2","ref":"ExESDB.ConsistencyChecker.html#start_consistency_monitoring/2"},{"type":"type","doc":"","title":"ExESDB.ConsistencyChecker.store_id/0","ref":"ExESDB.ConsistencyChecker.html#t:store_id/0"},{"type":"function","doc":"Performs a comprehensive consistency check across all cluster nodes for a given store.","title":"ExESDB.ConsistencyChecker.verify_cluster_consistency/1","ref":"ExESDB.ConsistencyChecker.html#verify_cluster_consistency/1"},{"type":"function","doc":"- `{:ok, report}` - Detailed consistency report\n- `{:error, reason}` - Error occurred during check","title":"Returns - ExESDB.ConsistencyChecker.verify_cluster_consistency/1","ref":"ExESDB.ConsistencyChecker.html#verify_cluster_consistency/1-returns"},{"type":"function","doc":"iex> ExESDB.ConsistencyChecker.verify_cluster_consistency(:my_store)\n    {:ok, %{\n      status: :consistent,\n      nodes_checked: 3,\n      leader: :\"node1@host\",\n      members: [:\"node1@host\", :\"node2@host\", :\"node3@host\"],\n      raft_status: :healthy,\n      potential_issues: []\n    }}","title":"Example - ExESDB.ConsistencyChecker.verify_cluster_consistency/1","ref":"ExESDB.ConsistencyChecker.html#verify_cluster_consistency/1-example"},{"type":"function","doc":"Verifies that all nodes agree on cluster membership.","title":"ExESDB.ConsistencyChecker.verify_membership_consensus/1","ref":"ExESDB.ConsistencyChecker.html#verify_membership_consensus/1"},{"type":"module","doc":"Critical infrastructure supervisor that manages core ExESDB components.\n\nThis supervisor uses :one_for_all strategy because these components are \ntightly coupled and must restart together to maintain consistency.\n\nStartup order:\n1. PersistenceSystem: Manages streams, snapshots, and subscriptions (foundation)\n2. NotificationSystem: Manages leadership and event emission (depends on persistence)\n3. StoreSystem: Manages store lifecycle and clustering (depends on persistence & notification)\n\nThe NotificationSystem includes:\n- LeaderSystem: Leadership responsibilities and subscription management\n- EmitterSystem: Event emission and distribution\n\nThis ensures that leadership and event distribution are core capabilities\navailable in both single-node and cluster modes.","title":"ExESDB.CoreSystem","ref":"ExESDB.CoreSystem.html"},{"type":"function","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","title":"ExESDB.CoreSystem.child_spec/1","ref":"ExESDB.CoreSystem.html#child_spec/1"},{"type":"function","doc":"","title":"ExESDB.CoreSystem.start_link/1","ref":"ExESDB.CoreSystem.html#start_link/1"},{"type":"module","doc":"Supervisor for event emission components.\n\nThis supervisor manages the emitter pools that handle event distribution\nto subscribers. Only active when this node is the cluster leader.\n\nComponents:\n- EmitterPools: PartitionSupervisor managing dynamic emitter pools","title":"ExESDB.EmitterSystem","ref":"ExESDB.EmitterSystem.html"},{"type":"function","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","title":"ExESDB.EmitterSystem.child_spec/1","ref":"ExESDB.EmitterSystem.html#child_spec/1"},{"type":"function","doc":"","title":"ExESDB.EmitterSystem.start_link/1","ref":"ExESDB.EmitterSystem.html#start_link/1"},{"type":"module","doc":"As part of the ExESDB.System, \n  the EmitterWorker is responsible for managing the communication \n  between the Event Store and the PubSub mechanism.","title":"ExESDB.EmitterWorker","ref":"ExESDB.EmitterWorker.html"},{"type":"function","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","title":"ExESDB.EmitterWorker.child_spec/1","ref":"ExESDB.EmitterWorker.html#child_spec/1"},{"type":"function","doc":"","title":"ExESDB.EmitterWorker.start_link/1","ref":"ExESDB.EmitterWorker.html#start_link/1"},{"type":"module","doc":"As part of the ExESDB.System, ExESDB.Emitters is responsible for managing the\n  lifetime of the Emitter processes.","title":"ExESDB.Emitters","ref":"ExESDB.Emitters.html"},{"type":"function","doc":"","title":"ExESDB.Emitters.start_emitter_pool/3","ref":"ExESDB.Emitters.html#start_emitter_pool/3"},{"type":"function","doc":"Stops an EmitterPool for a given subscription.","title":"ExESDB.Emitters.stop_emitter_pool/2","ref":"ExESDB.Emitters.html#stop_emitter_pool/2"},{"type":"function","doc":"Updates an EmitterPool with new subscription data.\nThis is typically called when the subscriber PID changes.","title":"ExESDB.Emitters.update_emitter_pool/2","ref":"ExESDB.Emitters.html#update_emitter_pool/2"},{"type":"module","doc":"This module contains the environment variables that are used by ExESDB","title":"ExESDB.EnVars","ref":"ExESDB.EnVars.html"},{"type":"function","doc":"","title":"ExESDB.EnVars.cluster_secret/0","ref":"ExESDB.EnVars.html#cluster_secret/0"},{"type":"function","doc":"Returns the data directory. default: `/data`","title":"ExESDB.EnVars.data_dir/0","ref":"ExESDB.EnVars.html#data_dir/0"},{"type":"function","doc":"Returns the db type. `single` or `cluster`. default: `single`","title":"ExESDB.EnVars.db_type/0","ref":"ExESDB.EnVars.html#db_type/0"},{"type":"function","doc":"Returns the gossip multicast address. default: `255.255.255.255`","title":"ExESDB.EnVars.gossip_multicast_addr/0","ref":"ExESDB.EnVars.html#gossip_multicast_addr/0"},{"type":"function","doc":"Returns the name of the pub/sub. default: `ex_esdb_pub_sub`","title":"ExESDB.EnVars.pub_sub/0","ref":"ExESDB.EnVars.html#pub_sub/0"},{"type":"function","doc":"Returns the idle readers timeout in milliseconds. default: `10_000`","title":"ExESDB.EnVars.reader_idle_ms/0","ref":"ExESDB.EnVars.html#reader_idle_ms/0"},{"type":"function","doc":"Returns the store description. default: `nil`","title":"ExESDB.EnVars.store_description/0","ref":"ExESDB.EnVars.html#store_description/0"},{"type":"function","doc":"Returns the khepri store id. default: `ex_esdb_store`","title":"ExESDB.EnVars.store_id/0","ref":"ExESDB.EnVars.html#store_id/0"},{"type":"function","doc":"Returns the store tags as comma-separated values. default: `nil`","title":"ExESDB.EnVars.store_tags/0","ref":"ExESDB.EnVars.html#store_tags/0"},{"type":"function","doc":"Returns the timeout in milliseconds. default: `10_000`","title":"ExESDB.EnVars.timeout/0","ref":"ExESDB.EnVars.html#timeout/0"},{"type":"function","doc":"Returns the idle writers timeout in milliseconds. default: `10_000`","title":"ExESDB.EnVars.writer_idle_ms/0","ref":"ExESDB.EnVars.html#writer_idle_ms/0"},{"type":"module","doc":"This module contains the event projector functionality","title":"ExESDB.EventProjector","ref":"ExESDB.EventProjector.html"},{"type":"function","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","title":"ExESDB.EventProjector.child_spec/1","ref":"ExESDB.EventProjector.html#child_spec/1"},{"type":"function","doc":"","title":"ExESDB.EventProjector.start_link/1","ref":"ExESDB.EventProjector.html#start_link/1"},{"type":"module","doc":"@deprecated \"Use ExESDB.GatewaySystem instead\"\n  \n  The GatewaySupervisor is responsible for starting and supervising the\n  GatewayWorkers.\n  \n  This module is deprecated in favor of ExESDB.GatewaySystem which provides\n  improved fault tolerance with pooled workers.","title":"ExESDB.GatewaySupervisor","ref":"ExESDB.GatewaySupervisor.html"},{"type":"function","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","title":"ExESDB.GatewaySupervisor.child_spec/1","ref":"ExESDB.GatewaySupervisor.html#child_spec/1"},{"type":"function","doc":"","title":"ExESDB.GatewaySupervisor.start_link/1","ref":"ExESDB.GatewaySupervisor.html#start_link/1"},{"type":"module","doc":"Supervisor for gateway components providing external interface.\n\nThis supervisor manages a pool of gateway workers for high availability\nand load distribution.\n\nComponents:\n- GatewayWorkers: Pool of GatewayWorkers via PartitionSupervisor\n- PubSub: External communication (conditional)","title":"ExESDB.GatewaySystem","ref":"ExESDB.GatewaySystem.html"},{"type":"function","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","title":"ExESDB.GatewaySystem.child_spec/1","ref":"ExESDB.GatewaySystem.html#child_spec/1"},{"type":"function","doc":"","title":"ExESDB.GatewaySystem.start_link/1","ref":"ExESDB.GatewaySystem.html#start_link/1"},{"type":"module","doc":"GatewayWorker processes are started on each node in the cluster,\n  and contain the implementation functions for the Gater.API.","title":"ExESDB.GatewayWorker","ref":"ExESDB.GatewayWorker.html"},{"type":"function","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","title":"ExESDB.GatewayWorker.child_spec/1","ref":"ExESDB.GatewayWorker.html#child_spec/1"},{"type":"type","doc":"","title":"ExESDB.GatewayWorker.error/0","ref":"ExESDB.GatewayWorker.html#t:error/0"},{"type":"function","doc":"","title":"ExESDB.GatewayWorker.gateway_worker_name/1","ref":"ExESDB.GatewayWorker.html#gateway_worker_name/1"},{"type":"type","doc":"","title":"ExESDB.GatewayWorker.selector_type/0","ref":"ExESDB.GatewayWorker.html#t:selector_type/0"},{"type":"function","doc":"","title":"ExESDB.GatewayWorker.start_link/1","ref":"ExESDB.GatewayWorker.html#start_link/1"},{"type":"type","doc":"","title":"ExESDB.GatewayWorker.store/0","ref":"ExESDB.GatewayWorker.html#t:store/0"},{"type":"type","doc":"","title":"ExESDB.GatewayWorker.stream/0","ref":"ExESDB.GatewayWorker.html#t:stream/0"},{"type":"type","doc":"","title":"ExESDB.GatewayWorker.subscription_name/0","ref":"ExESDB.GatewayWorker.html#t:subscription_name/0"},{"type":"type","doc":"","title":"ExESDB.GatewayWorker.subscription_type/0","ref":"ExESDB.GatewayWorker.html#t:subscription_type/0"},{"type":"module","doc":"Provides functions for distributing load over the cluster.","title":"ExESDB.HashRing","ref":"ExESDB.HashRing.html"},{"type":"function","doc":"","title":"ExESDB.HashRing.get_core_for_stream/1","ref":"ExESDB.HashRing.html#get_core_for_stream/1"},{"type":"function","doc":"","title":"ExESDB.HashRing.get_node_for_stream/1","ref":"ExESDB.HashRing.html#get_node_for_stream/1"},{"type":"module","doc":"This module supervises the Leader Subsystem.","title":"ExESDB.LeaderSystem","ref":"ExESDB.LeaderSystem.html"},{"type":"function","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","title":"ExESDB.LeaderSystem.child_spec/1","ref":"ExESDB.LeaderSystem.html#child_spec/1"},{"type":"function","doc":"","title":"ExESDB.LeaderSystem.start_link/1","ref":"ExESDB.LeaderSystem.html#start_link/1"},{"type":"module","doc":"As part of the ExESDB.System, the SubscriptionsTracker is responsible for\n  observing the subscriptions that are maintained in the Store.\n\n  Since Khepri triggers are executed on the leader node, the SubscriptionsTracker\n  will be instructed to start the Emitters system on the leader node whenever a new subscription\n  is registered.\n\n  When a Subscription is deleted, the SubscriptionsTracker will instruct the Emitters system to stop \n  the associated EmitterPool.","title":"ExESDB.LeaderTracker","ref":"ExESDB.LeaderTracker.html"},{"type":"function","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","title":"ExESDB.LeaderTracker.child_spec/1","ref":"ExESDB.LeaderTracker.html#child_spec/1"},{"type":"function","doc":"","title":"ExESDB.LeaderTracker.start_link/1","ref":"ExESDB.LeaderTracker.html#start_link/1"},{"type":"module","doc":"This module contains the leader's reponsibilities for the cluster.","title":"ExESDB.LeaderWorker","ref":"ExESDB.LeaderWorker.html"},{"type":"function","doc":"Activates the LeaderWorker for the given store.\n\nThis function is called when this node becomes the cluster leader.","title":"ExESDB.LeaderWorker.activate/1","ref":"ExESDB.LeaderWorker.html#activate/1"},{"type":"function","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","title":"ExESDB.LeaderWorker.child_spec/1","ref":"ExESDB.LeaderWorker.html#child_spec/1"},{"type":"function","doc":"","title":"ExESDB.LeaderWorker.start_link/1","ref":"ExESDB.LeaderWorker.html#start_link/1"},{"type":"module","doc":"Custom logger filters to reduce noise from Ra, Khepri, and other verbose components","title":"ExESDB.LoggerFilters","ref":"ExESDB.LoggerFilters.html"},{"type":"function","doc":"Filter Khepri noise - reduce verbose operational messages","title":"ExESDB.LoggerFilters.filter_khepri/1","ref":"ExESDB.LoggerFilters.html#filter_khepri/1"},{"type":"function","doc":"Filter libcluster noise - reduce cluster formation chatter","title":"ExESDB.LoggerFilters.filter_libcluster/1","ref":"ExESDB.LoggerFilters.html#filter_libcluster/1"},{"type":"function","doc":"Filter Ra consensus library noise - only show errors and warnings","title":"ExESDB.LoggerFilters.filter_ra/1","ref":"ExESDB.LoggerFilters.html#filter_ra/1"},{"type":"function","doc":"Filter Swarm noise - already provided by BCUtils but adding our own","title":"ExESDB.LoggerFilters.filter_swarm/1","ref":"ExESDB.LoggerFilters.html#filter_swarm/1"},{"type":"module","doc":"Provides metrics for the event store.","title":"ExESDB.Metrics","ref":"ExESDB.Metrics.html"},{"type":"module","doc":"Provides fast failure detection and cluster health monitoring to handle hard node crashes.\n\nThis module implements a multi-layer approach:\n1. Active health probing of cluster nodes\n2. Fast detection of unresponsive nodes\n3. Proactive cleanup of Swarm registrations\n4. Coordination with Khepri cluster management","title":"ExESDB.NodeMonitor","ref":"ExESDB.NodeMonitor.html"},{"type":"function","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","title":"ExESDB.NodeMonitor.child_spec/1","ref":"ExESDB.NodeMonitor.html#child_spec/1"},{"type":"function","doc":"Get current cluster health status","title":"ExESDB.NodeMonitor.health_status/0","ref":"ExESDB.NodeMonitor.html#health_status/0"},{"type":"function","doc":"Force probe a specific node","title":"ExESDB.NodeMonitor.probe_node/1","ref":"ExESDB.NodeMonitor.html#probe_node/1"},{"type":"function","doc":"Start the node monitor","title":"ExESDB.NodeMonitor.start_link/1","ref":"ExESDB.NodeMonitor.html#start_link/1"},{"type":"module","doc":"Supervisor for event notification and distribution components.\n\nThis supervisor manages the core event notification functionality:\n- LeaderSystem: Leadership responsibilities and subscription management\n- EmitterSystem: Event emission and distribution\n\nThis is a core component that runs in both single-node and cluster modes.\nThe leadership determination happens at the store level, not the clustering level.","title":"ExESDB.NotificationSystem","ref":"ExESDB.NotificationSystem.html"},{"type":"function","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","title":"ExESDB.NotificationSystem.child_spec/1","ref":"ExESDB.NotificationSystem.html#child_spec/1"},{"type":"function","doc":"","title":"ExESDB.NotificationSystem.start_link/1","ref":"ExESDB.NotificationSystem.html#start_link/1"},{"type":"module","doc":"This module contains the options helper functions for ExESDB","title":"ExESDB.Options","ref":"ExESDB.Options.html"},{"type":"function","doc":"","title":"ExESDB.Options.app_env/0","ref":"ExESDB.Options.html#app_env/0"},{"type":"function","doc":"","title":"ExESDB.Options.app_env/1","ref":"ExESDB.Options.html#app_env/1"},{"type":"function","doc":"","title":"ExESDB.Options.data_dir/0","ref":"ExESDB.Options.html#data_dir/0"},{"type":"function","doc":"","title":"ExESDB.Options.db_type/0","ref":"ExESDB.Options.html#db_type/0"},{"type":"function","doc":"","title":"ExESDB.Options.pub_sub/0","ref":"ExESDB.Options.html#pub_sub/0"},{"type":"function","doc":"","title":"ExESDB.Options.reader_idle_ms/0","ref":"ExESDB.Options.html#reader_idle_ms/0"},{"type":"function","doc":"","title":"ExESDB.Options.store_description/0","ref":"ExESDB.Options.html#store_description/0"},{"type":"function","doc":"","title":"ExESDB.Options.store_id/0","ref":"ExESDB.Options.html#store_id/0"},{"type":"function","doc":"","title":"ExESDB.Options.store_tags/0","ref":"ExESDB.Options.html#store_tags/0"},{"type":"function","doc":"","title":"ExESDB.Options.sys_env/1","ref":"ExESDB.Options.html#sys_env/1"},{"type":"function","doc":"","title":"ExESDB.Options.timeout/0","ref":"ExESDB.Options.html#timeout/0"},{"type":"function","doc":"","title":"ExESDB.Options.topologies/0","ref":"ExESDB.Options.html#topologies/0"},{"type":"function","doc":"","title":"ExESDB.Options.writer_idle_ms/0","ref":"ExESDB.Options.html#writer_idle_ms/0"},{"type":"module","doc":"Supervisor for persistence layer components.\n\nThis supervisor manages all data persistence components that can\noperate independently of each other.\n\nComponents:\n- Streams: Stream read/write operations\n- Snapshots: Snapshot management\n- Subscriptions: Subscription management","title":"ExESDB.PersistenceSystem","ref":"ExESDB.PersistenceSystem.html"},{"type":"function","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","title":"ExESDB.PersistenceSystem.child_spec/1","ref":"ExESDB.PersistenceSystem.html#child_spec/1"},{"type":"function","doc":"","title":"ExESDB.PersistenceSystem.start_link/1","ref":"ExESDB.PersistenceSystem.html#start_link/1"},{"type":"module","doc":"The ExESDB Snapshots SubSystem.","title":"ExESDB.Snapshots","ref":"ExESDB.Snapshots.html"},{"type":"function","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","title":"ExESDB.Snapshots.child_spec/1","ref":"ExESDB.Snapshots.html#child_spec/1"},{"type":"function","doc":"","title":"ExESDB.Snapshots.path/3","ref":"ExESDB.Snapshots.html#path/3"},{"type":"function","doc":"Returns the key for a snapshot as a Khepri Path.","title":"Description - ExESDB.Snapshots.path/3","ref":"ExESDB.Snapshots.html#path/3-description"},{"type":"function","doc":"iex> ExESDB.Snapshots.path(\"source_uuid\", \"stream_uuid\", 1)\n    [:snapshots, \"source_uuid\", \"stream_uuid\", \"000000001\"]","title":"Examples - ExESDB.Snapshots.path/3","ref":"ExESDB.Snapshots.html#path/3-examples"},{"type":"function","doc":"","title":"ExESDB.Snapshots.start_link/1","ref":"ExESDB.Snapshots.html#start_link/1"},{"type":"module","doc":"Provides functions for reading snapshots","title":"ExESDB.SnapshotsReader","ref":"ExESDB.SnapshotsReader.html"},{"type":"function","doc":"","title":"ExESDB.SnapshotsReader.cluster_id/3","ref":"ExESDB.SnapshotsReader.html#cluster_id/3"},{"type":"function","doc":"","title":"ExESDB.SnapshotsReader.hr_snapshots_reader_name/3","ref":"ExESDB.SnapshotsReader.html#hr_snapshots_reader_name/3"},{"type":"function","doc":"","title":"ExESDB.SnapshotsReader.list_snapshots/3","ref":"ExESDB.SnapshotsReader.html#list_snapshots/3"},{"type":"function","doc":"","title":"ExESDB.SnapshotsReader.read_snapshot/4","ref":"ExESDB.SnapshotsReader.html#read_snapshot/4"},{"type":"function","doc":"Reads a snapshot version from the store \n  for the given source and stream uuids","title":"Description - ExESDB.SnapshotsReader.read_snapshot/4","ref":"ExESDB.SnapshotsReader.html#read_snapshot/4-description"},{"type":"function","doc":"* `store` - the store to read from\n   * `source_uuid` - the source uuid\n   * `stream_uuid` - the stream uuid\n   * `version` - the version of the snapshot to read","title":"Parameters - ExESDB.SnapshotsReader.read_snapshot/4","ref":"ExESDB.SnapshotsReader.html#read_snapshot/4-parameters"},{"type":"function","doc":"* `{:ok, map()}` - the snapshot","title":"Returns - ExESDB.SnapshotsReader.read_snapshot/4","ref":"ExESDB.SnapshotsReader.html#read_snapshot/4-returns"},{"type":"function","doc":"","title":"ExESDB.SnapshotsReader.start_worker/3","ref":"ExESDB.SnapshotsReader.html#start_worker/3"},{"type":"module","doc":"A pool of `ExESDB.SnapshotsReaderWorker` processes.","title":"ExESDB.SnapshotsReaderPool","ref":"ExESDB.SnapshotsReaderPool.html"},{"type":"module","doc":"A worker process for reading snapshots from the event store.","title":"ExESDB.SnapshotsReaderWorker","ref":"ExESDB.SnapshotsReaderWorker.html"},{"type":"function","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","title":"ExESDB.SnapshotsReaderWorker.child_spec/1","ref":"ExESDB.SnapshotsReaderWorker.html#child_spec/1"},{"type":"function","doc":"","title":"ExESDB.SnapshotsReaderWorker.start_link/1","ref":"ExESDB.SnapshotsReaderWorker.html#start_link/1"},{"type":"module","doc":"The API for interacting with ExESDB Snapshots Writers.\n It functions as an API for SnapshotsWriterWorkers, \n by requesting a worker from the Cluster. \n If no worker is available for the specific combination of store, source_uuid, and stream_uuid,\n then a new worker is started.","title":"ExESDB.SnapshotsWriter","ref":"ExESDB.SnapshotsWriter.html"},{"type":"function","doc":"","title":"ExESDB.SnapshotsWriter.cluster_id/3","ref":"ExESDB.SnapshotsWriter.html#cluster_id/3"},{"type":"function","doc":"","title":"ExESDB.SnapshotsWriter.delete_snapshot/4","ref":"ExESDB.SnapshotsWriter.html#delete_snapshot/4"},{"type":"function","doc":"","title":"ExESDB.SnapshotsWriter.hr_snapshots_writer_name/3","ref":"ExESDB.SnapshotsWriter.html#hr_snapshots_writer_name/3"},{"type":"function","doc":"","title":"ExESDB.SnapshotsWriter.record_snapshot/5","ref":"ExESDB.SnapshotsWriter.html#record_snapshot/5"},{"type":"module","doc":"A pool of `ExESDB.SnapshotsWriterWorker` processes.","title":"ExESDB.SnapshotsWriterPool","ref":"ExESDB.SnapshotsWriterPool.html"},{"type":"module","doc":"A worker process for writing snapshots to the event store.","title":"ExESDB.SnapshotsWriterWorker","ref":"ExESDB.SnapshotsWriterWorker.html"},{"type":"function","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","title":"ExESDB.SnapshotsWriterWorker.child_spec/1","ref":"ExESDB.SnapshotsWriterWorker.html#child_spec/1"},{"type":"function","doc":"Starts a new `ExESDB.SnapshotsWriterWorker` process.","title":"ExESDB.SnapshotsWriterWorker.start_link/1","ref":"ExESDB.SnapshotsWriterWorker.html#start_link/1"},{"type":"module","doc":"A GenServer wrapper around :khepri to act as a distributed event store.","title":"ExESDB.Store","ref":"ExESDB.Store.html"},{"type":"function","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","title":"ExESDB.Store.child_spec/1","ref":"ExESDB.Store.html#child_spec/1"},{"type":"function","doc":"Get the current state of the store.","title":"ExESDB.Store.get_state/0","ref":"ExESDB.Store.html#get_state/0"},{"type":"function","doc":"- `{:ok, state}`  if successful.\n    - `{:error, reason}` if unsuccessful.","title":"Returns - ExESDB.Store.get_state/0","ref":"ExESDB.Store.html#get_state/0-returns"},{"type":"function","doc":"","title":"ExESDB.Store.start_link/1","ref":"ExESDB.Store.html#start_link/1"},{"type":"module","doc":"GenServer responsible for coordinating Khepri cluster formation and preventing split-brain scenarios.\n\nThis module handles:\n- Detecting existing clusters\n- Coordinator election\n- Coordinated cluster joining\n- Split-brain prevention","title":"ExESDB.StoreCoordinator","ref":"ExESDB.StoreCoordinator.html"},{"type":"function","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","title":"ExESDB.StoreCoordinator.child_spec/1","ref":"ExESDB.StoreCoordinator.html#child_spec/1"},{"type":"function","doc":"Attempts to join a Khepri cluster using coordinated approach to prevent split-brain.\nReturns one of: :ok, :coordinator, :no_nodes, :waiting, :failed","title":"ExESDB.StoreCoordinator.join_cluster/1","ref":"ExESDB.StoreCoordinator.html#join_cluster/1"},{"type":"function","doc":"Checks if this node should handle nodeup events (i.e., not already in a cluster)","title":"ExESDB.StoreCoordinator.should_handle_nodeup?/1","ref":"ExESDB.StoreCoordinator.html#should_handle_nodeup?/1"},{"type":"function","doc":"","title":"ExESDB.StoreCoordinator.start_link/1","ref":"ExESDB.StoreCoordinator.html#start_link/1"},{"type":"module","doc":"This module provides functions to get information about the EXESDB event store.","title":"ExESDB.StoreInfo","ref":"ExESDB.StoreInfo.html"},{"type":"function","doc":"Returns the list of streams in the store.","title":"ExESDB.StoreInfo.get_streams!/1","ref":"ExESDB.StoreInfo.html#get_streams!/1"},{"type":"function","doc":"","title":"ExESDB.StoreInfo.get_streams_raw/1","ref":"ExESDB.StoreInfo.html#get_streams_raw/1"},{"type":"module","doc":"Supervisor for store-related components.\n\nThis supervisor manages the store lifecycle and clustering components.\nUses :rest_for_one strategy to ensure proper startup order.\n\nStartup order (critical for distributed coordination):\n1. Store: Core store GenServer - must be fully operational first\n2. StoreCluster: Clustering coordination - depends on Store being ready\n3. StoreRegistry: Distributed store registry - starts after Store system is stable\n\nThis order ensures StoreRegistry only announces a store that is actually ready\nto handle requests, preventing race conditions in distributed environments.","title":"ExESDB.StoreSystem","ref":"ExESDB.StoreSystem.html"},{"type":"function","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","title":"ExESDB.StoreSystem.child_spec/1","ref":"ExESDB.StoreSystem.html#child_spec/1"},{"type":"function","doc":"","title":"ExESDB.StoreSystem.start_link/1","ref":"ExESDB.StoreSystem.html#start_link/1"},{"type":"module","doc":"A GenServer wrapper around :khepri to act as a distributed event store.\n  Inspired by EventStoreDB's API.","title":"ExESDB.StoreWorker","ref":"ExESDB.StoreWorker.html"},{"type":"function","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","title":"ExESDB.StoreWorker.child_spec/1","ref":"ExESDB.StoreWorker.html#child_spec/1"},{"type":"function","doc":"Get the current state of the store.","title":"ExESDB.StoreWorker.get_state/0","ref":"ExESDB.StoreWorker.html#get_state/0"},{"type":"function","doc":"- `{:ok, state}`  if successful.\n    - `{:error, reason}` if unsuccessful.","title":"Returns - ExESDB.StoreWorker.get_state/0","ref":"ExESDB.StoreWorker.html#get_state/0-returns"},{"type":"function","doc":"","title":"ExESDB.StoreWorker.start_link/1","ref":"ExESDB.StoreWorker.html#start_link/1"},{"type":"module","doc":"The ExESDB Streams SubSystem.","title":"ExESDB.Streams","ref":"ExESDB.Streams.html"},{"type":"function","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","title":"ExESDB.Streams.child_spec/1","ref":"ExESDB.Streams.html#child_spec/1"},{"type":"function","doc":"","title":"ExESDB.Streams.start_link/1","ref":"ExESDB.Streams.html#start_link/1"},{"type":"module","doc":"Provides helper functions for working with event store streams.","title":"ExESDB.StreamsHelper","ref":"ExESDB.StreamsHelper.html"},{"type":"function","doc":"","title":"ExESDB.StreamsHelper.calculate_versions/3","ref":"ExESDB.StreamsHelper.html#calculate_versions/3"},{"type":"function","doc":"Returns the version of the stream using 0-based indexing.","title":"ExESDB.StreamsHelper.get_version!/2","ref":"ExESDB.StreamsHelper.html#get_version!/2"},{"type":"function","doc":"- `store` is the name of the store.\n   - `stream_id` is the name of the stream.","title":"Parameters - ExESDB.StreamsHelper.get_version!/2","ref":"ExESDB.StreamsHelper.html#get_version!/2-parameters"},{"type":"function","doc":"- `version` (0-based) or `-1` if the stream does not exist.\n   This means:\n   - New stream (no events): -1\n   - Stream with 1 event: 0 (version of latest event)\n   - Stream with 2 events: 1 (version of latest event)\n   - etc.","title":"Returns - ExESDB.StreamsHelper.get_version!/2","ref":"ExESDB.StreamsHelper.html#get_version!/2-returns"},{"type":"function","doc":"","title":"ExESDB.StreamsHelper.pad_version/2","ref":"ExESDB.StreamsHelper.html#pad_version/2"},{"type":"function","doc":"","title":"ExESDB.StreamsHelper.stream_exists?/2","ref":"ExESDB.StreamsHelper.html#stream_exists?/2"},{"type":"function","doc":"","title":"ExESDB.StreamsHelper.to_event_record/5","ref":"ExESDB.StreamsHelper.html#to_event_record/5"},{"type":"function","doc":"","title":"ExESDB.StreamsHelper.version_to_integer/1","ref":"ExESDB.StreamsHelper.html#version_to_integer/1"},{"type":"module","doc":"This module is responsible for reading events from a stream.","title":"ExESDB.StreamsReader","ref":"ExESDB.StreamsReader.html"},{"type":"function","doc":"Returns a list of all streams in the store.","title":"ExESDB.StreamsReader.get_streams/1","ref":"ExESDB.StreamsReader.html#get_streams/1"},{"type":"function","doc":"- `store` is the name of the store.","title":"Parameters - ExESDB.StreamsReader.get_streams/1","ref":"ExESDB.StreamsReader.html#get_streams/1-parameters"},{"type":"function","doc":"- `{:ok, streams}`  if successful.","title":"Returns - ExESDB.StreamsReader.get_streams/1","ref":"ExESDB.StreamsReader.html#get_streams/1-returns"},{"type":"function","doc":"Streams events from `stream` in batches of `count` events, in a `direction`.","title":"ExESDB.StreamsReader.stream_events/5","ref":"ExESDB.StreamsReader.html#stream_events/5"},{"type":"function","doc":"","title":"ExESDB.StreamsReader.worker_id/2","ref":"ExESDB.StreamsReader.html#worker_id/2"},{"type":"module","doc":"As part of the ExESDB.System,","title":"ExESDB.StreamsReaderPool","ref":"ExESDB.StreamsReaderPool.html"},{"type":"function","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","title":"ExESDB.StreamsReaderPool.child_spec/1","ref":"ExESDB.StreamsReaderPool.html#child_spec/1"},{"type":"module","doc":"Provides functions for reading and streaming events from the event store.","title":"ExESDB.StreamsReaderWorker","ref":"ExESDB.StreamsReaderWorker.html"},{"type":"function","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","title":"ExESDB.StreamsReaderWorker.child_spec/1","ref":"ExESDB.StreamsReaderWorker.html#child_spec/1"},{"type":"function","doc":"","title":"ExESDB.StreamsReaderWorker.start_link/1","ref":"ExESDB.StreamsReaderWorker.html#start_link/1"},{"type":"module","doc":"This module is responsible for writing events to a stream.\n  It is actually an API style wrapper around the StreamsWriterWorker.","title":"ExESDB.StreamsWriter","ref":"ExESDB.StreamsWriter.html"},{"type":"function","doc":"","title":"ExESDB.StreamsWriter.append_events/4","ref":"ExESDB.StreamsWriter.html#append_events/4"},{"type":"function","doc":"","title":"ExESDB.StreamsWriter.hr_worker_id_atom/2","ref":"ExESDB.StreamsWriter.html#hr_worker_id_atom/2"},{"type":"function","doc":"","title":"ExESDB.StreamsWriter.worker_id/2","ref":"ExESDB.StreamsWriter.html#worker_id/2"},{"type":"module","doc":"As part of the ExESDB.System,","title":"ExESDB.StreamsWriterPool","ref":"ExESDB.StreamsWriterPool.html"},{"type":"function","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","title":"ExESDB.StreamsWriterPool.child_spec/1","ref":"ExESDB.StreamsWriterPool.html#child_spec/1"},{"type":"module","doc":"Provides functions for writing streams","title":"ExESDB.StreamsWriterWorker","ref":"ExESDB.StreamsWriterWorker.html"},{"type":"function","doc":"Returns a child spec for a streams writer worker.\n  Please note that the restart strategy is set to `:temporary`\n  to avoid restarting the worker when the idle timeout is reached.","title":"ExESDB.StreamsWriterWorker.child_spec/1","ref":"ExESDB.StreamsWriterWorker.html#child_spec/1"},{"type":"function","doc":"","title":"ExESDB.StreamsWriterWorker.start_link/1","ref":"ExESDB.StreamsWriterWorker.html#start_link/1"},{"type":"module","doc":"Provides functions for working with event store subscriptions.","title":"ExESDB.Subscriptions","ref":"ExESDB.Subscriptions.html"},{"type":"function","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","title":"ExESDB.Subscriptions.child_spec/1","ref":"ExESDB.Subscriptions.html#child_spec/1"},{"type":"function","doc":"","title":"ExESDB.Subscriptions.start_link/1","ref":"ExESDB.Subscriptions.html#start_link/1"},{"type":"module","doc":"Provides functions for working with event store subscriptions.","title":"ExESDB.SubscriptionsReader","ref":"ExESDB.SubscriptionsReader.html"},{"type":"function","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","title":"ExESDB.SubscriptionsReader.child_spec/1","ref":"ExESDB.SubscriptionsReader.html#child_spec/1"},{"type":"function","doc":"","title":"ExESDB.SubscriptionsReader.get_subscriptions/1","ref":"ExESDB.SubscriptionsReader.html#get_subscriptions/1"},{"type":"function","doc":"","title":"ExESDB.SubscriptionsReader.start_link/1","ref":"ExESDB.SubscriptionsReader.html#start_link/1"},{"type":"module","doc":"As part of the ExESDB.System, the SubscriptionsTracker is responsible for\n  observing the subscriptions that are maintained in the Store.\n\n  Since Khepri triggers are executed on the leader node, the SubscriptionsTracker\n  will be instructed to start the Emitters system on the leader node whenever a new subscription\n  is registered.\n\n  When a Subscription is deleted, the SubscriptionsTracker will instruct the Emitters system to stop \n  the associated EmitterPool.","title":"ExESDB.SubscriptionsTracker","ref":"ExESDB.SubscriptionsTracker.html"},{"type":"function","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","title":"ExESDB.SubscriptionsTracker.child_spec/1","ref":"ExESDB.SubscriptionsTracker.html#child_spec/1"},{"type":"function","doc":"","title":"ExESDB.SubscriptionsTracker.start_link/1","ref":"ExESDB.SubscriptionsTracker.html#start_link/1"},{"type":"module","doc":"Provides functions for working with event store subscriptions.","title":"ExESDB.SubscriptionsWriter","ref":"ExESDB.SubscriptionsWriter.html"},{"type":"function","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","title":"ExESDB.SubscriptionsWriter.child_spec/1","ref":"ExESDB.SubscriptionsWriter.html#child_spec/1"},{"type":"function","doc":"","title":"ExESDB.SubscriptionsWriter.delete_subscription/4","ref":"ExESDB.SubscriptionsWriter.html#delete_subscription/4"},{"type":"function","doc":"","title":"ExESDB.SubscriptionsWriter.put_subscription/6","ref":"ExESDB.SubscriptionsWriter.html#put_subscription/6"},{"type":"function","doc":"","title":"ExESDB.SubscriptionsWriter.put_subscription_sync/6","ref":"ExESDB.SubscriptionsWriter.html#put_subscription_sync/6"},{"type":"function","doc":"","title":"ExESDB.SubscriptionsWriter.start_link/1","ref":"ExESDB.SubscriptionsWriter.html#start_link/1"},{"type":"module","doc":"This module is the top level supervisor for the ExESDB system.\n  \n  It uses a layered supervision architecture for better fault tolerance:\n  \n  SINGLE NODE MODE:\n  1. CoreSystem: Critical infrastructure (PersistenceSystem + NotificationSystem + StoreSystem)\n  2. GatewaySystem: External interface with pooled workers\n  \n  CLUSTER MODE:\n  1. CoreSystem: Critical infrastructure (PersistenceSystem + NotificationSystem + StoreSystem)\n  2. LibCluster: Node discovery and connection (after core is ready)\n  3. ClusterSystem: Cluster coordination and membership\n  4. GatewaySystem: External interface (LAST - only after clustering is ready)\n  \n  NotificationSystem (part of CoreSystem) includes:\n  - LeaderSystem: Leadership responsibilities and subscription management\n  - EmitterSystem: Event emission and distribution\n  \n  IMPORTANT: Core functionality (Store, Persistence) must be fully operational \n  before any clustering/membership/registration components start. This ensures \n  the server is ready to handle requests before announcing itself to the cluster.\n  \n  In cluster mode, GatewaySystem starts LAST to prevent external connections\n  until the entire distributed system is properly initialized.\n  \n  Note: Store management is now handled by the distributed ex-esdb-gater API.","title":"ExESDB.System","ref":"ExESDB.System.html"},{"type":"function","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","title":"ExESDB.System.child_spec/1","ref":"ExESDB.System.html#child_spec/1"},{"type":"function","doc":"","title":"ExESDB.System.start/1","ref":"ExESDB.System.html#start/1"},{"type":"function","doc":"","title":"ExESDB.System.start_link/1","ref":"ExESDB.System.html#start_link/1"},{"type":"function","doc":"","title":"ExESDB.System.stop/1","ref":"ExESDB.System.html#stop/1"},{"type":"module","doc":"A module to calculate topic identifiers","title":"ExESDB.Topics","ref":"ExESDB.Topics.html"},{"type":"function","doc":"","title":"ExESDB.Topics.selector_hash/1","ref":"ExESDB.Topics.html#selector_hash/1"},{"type":"function","doc":"","title":"ExESDB.Topics.sub_topic/3","ref":"ExESDB.Topics.html#sub_topic/3"},{"type":"extras","doc":"# Architecture Decision Records","title":"Architecture Decision Records","ref":"adr.html"},{"type":"extras","doc":"","title":"2025.05.24 - Architecture Decision Records","ref":"adr.html#2025-05-24"},{"type":"extras","doc":"Given that Khepri triggers are executed on the Ra leader, emitter pools must run on the Ra leader.\nIn order to achieve this, it is necessary that a separate process exists, that monitors the Cluster and subscribes to Ra's leadership changes, by starting relevant emitter pools on the new leader.","title":"Emitter pools must run on the Ra leader. - Architecture Decision Records","ref":"adr.html#emitter-pools-must-run-on-the-ra-leader"},{"type":"extras","doc":"","title":"2025.05.02 - Architecture Decision Records","ref":"adr.html#2025-05-02"},{"type":"extras","doc":"Experimentation with :khepri's trigger model has shown that it is advised to use as few dependencies as possible, when defining the trigger functions. This is because :khepri uses :horus to decompile such functions and build a separate module. For this reason, we limit the dependencies for these trigger functions to :pg (Process Groups), which is an :erlang native module that allows for inter-process communication.","title":"Triggers will obtain Emitter Pids from :pg (Process Groups) - Architecture Decision Records","ref":"adr.html#triggers-will-obtain-emitter-pids-from-pg-process-groups"},{"type":"extras","doc":"","title":"2025.04.16 - Architecture Decision Records","ref":"adr.html#2025-04-16"},{"type":"extras","doc":"`subscribe_to` and `unsubscribe` will interact with the :subscriptions branch of the store, but instead of storing the pid of the subscriber, the subscriber will be stored in a registry.","title":"Subscriptions will be managed via a registry. - Architecture Decision Records","ref":"adr.html#subscriptions-will-be-managed-via-a-registry"},{"type":"extras","doc":"","title":"2025.04.13 - Architecture Decision Records","ref":"adr.html#2025-04-13"},{"type":"extras","doc":"- `:streams` will be used to store the events that are being read from and written to the store.\n- `:subscriptions` will be used to store the subscription information of so-called `Persistent Subscriptions`.\n- `:projections` can best be thought of as stored procedures that are used to transform the events in the `Streams` into a different format or to enrich the streams with secondary or derived events, to name a few possible use cases.\n\nThus:\n\n```mono\n:khepri\n  |\n  +-:manage_orders\n      |\n      +-:streams\n      |\n      +-:subscriptions\n      |\n      +-:projections\n```","title":"Each Store will contain separate branches for Streams, Subscriptions, and Projections - Architecture Decision Records","ref":"adr.html#each-store-will-contain-separate-branches-for-streams-subscriptions-and-projections"},{"type":"extras","doc":"# Changelog","title":"Changelog","ref":"changelog.html"},{"type":"extras","doc":"","title":"version 0.1.2 (2025.07.14) - Changelog","ref":"changelog.html#version-0-1-2-2025-07-14"},{"type":"extras","doc":"#### New Environment Variables\n\n- **`EX_ESDB_STORE_DESCRIPTION`**: Human-readable description of the store for documentation and operational purposes\n- **`EX_ESDB_STORE_TAGS`**: Comma-separated tags for store categorization and filtering (e.g., \"production,cluster,core\")\n\n#### Rich Store Configuration\n\n- **Operational Metadata**: Added `created_at`, `version`, and `status` fields to store configuration\n- **Resource Management**: Added `priority` and `auto_start` fields for resource allocation control\n- **Administrative Info**: Enhanced store registry with `tags`, `environment`, and `description` fields\n- **Enhanced Querying**: Store registry now supports filtering by tags, environment, priority, and other metadata\n\n#### Configuration Integration\n\n- **Runtime Configuration**: New environment variables integrated into `config/runtime.exs`\n- **Options System**: Added parsers in `ExESDB.Options` with comma-separated tag parsing\n- **Store Registry**: Enhanced `build_store_config/1` to include all new metadata fields\n- **Development Environment**: Updated `dev-env/*.yaml` files with new environment variables","title":"Store Configuration Enhancement - Changelog","ref":"changelog.html#store-configuration-enhancement"},{"type":"extras","doc":"#### NotificationSystem Introduction\n\n- **New Core Component**: Created `ExESDB.NotificationSystem` as a core supervisor for event notification\n- **Leadership Integration**: Moved `LeaderSystem` from clustering layer to core system\n- **Core System Enhancement**: Updated `CoreSystem` to include `NotificationSystem` alongside `PersistenceSystem` and `StoreSystem`\n- **Supervision Order**: `PersistenceSystem` → `NotificationSystem` → `StoreSystem` for proper dependency management\n\n#### LeaderWorker Availability Fix\n\n- **Core System Integration**: LeaderWorker now starts as part of core system, not clustering components\n- **Startup Order**: LeaderWorker is available before clustering components attempt to use it\n- **Resolved `:noproc` Error**: Fixed LeaderWorker activation failures by ensuring it's always running when needed\n- **Single and Cluster Mode**: LeaderWorker now available in both single-node and cluster modes\n\n#### System Architecture Cleanup\n\n- **Removed LeadershipSystem**: Consolidated functionality into `NotificationSystem`\n- **Cleaner Separation**: Core functionality (leadership, events) vs clustering (coordination, membership)\n- **Improved Documentation**: Updated supervision tree documentation to reflect new architecture\n- **Simplified Dependencies**: Reduced coupling between core and clustering components","title":"Architectural Refactoring - Changelog","ref":"changelog.html#architectural-refactoring"},{"type":"extras","doc":"#### Graceful Shutdown Implementation\n\n- **Universal Coverage**: All 18 GenServer processes now implement graceful shutdown\n- **Terminate Callbacks**: Added `terminate/2` callbacks to all GenServers for proper cleanup\n- **Exit Trapping**: Enabled `Process.flag(:trap_exit, true)` on all GenServers\n- **Resource Cleanup**: Proper cleanup of Swarm registrations, PubSub subscriptions, and Khepri stores\n\n#### Enhanced Process Lifecycle\n\n- **Swarm Registration Cleanup**: Worker processes properly unregister from Swarm on shutdown\n- **PubSub Subscription Cleanup**: EventProjector properly unsubscribes from topics\n- **Khepri Store Shutdown**: Store processes gracefully stop Khepri instances\n- **Network Monitoring**: NodeMonitor properly disables network monitoring on shutdown","title":"Process Management Enhancement - Changelog","ref":"changelog.html#process-management-enhancement"},{"type":"extras","doc":"#### Configuration Updates\n\n- **proc-sup Configuration**: Added description \"Process Supervisor Event Store\" and tags \"development,cluster,proc-sup,core\"\n- **reg-gh Configuration**: Added description \"Registration System Event Store\" and tags \"development,cluster,reg-gh,registration\"\n- **Environment-Specific Tags**: Different tags for development vs production environments\n- **Consistent Formatting**: Standardized environment variable layout across all configuration files","title":"Development Environment - Changelog","ref":"changelog.html#development-environment"},{"type":"extras","doc":"#### Operational Improvements\n\n- **Enhanced Monitoring**: Rich store metadata enables better operational visibility\n- **Improved Debugging**: Store descriptions and tags help identify issues faster\n- **Better Resource Management**: Priority and auto-start fields enable fine-grained control\n- **Cleaner Shutdown**: All processes terminate gracefully without resource leaks\n\n#### Development Experience\n\n- **Clearer Architecture**: Separation of core vs clustering concerns\n- **Consistent Configuration**: Standardized environment variable management\n- **Better Testability**: Core components can be tested independently of clustering\n- **Simplified Debugging**: LeaderWorker availability issues resolved\n\n#### System Reliability\n\n- **Reduced Race Conditions**: Proper startup order prevents timing-related failures\n- **Resource Leak Prevention**: Graceful shutdown prevents resource accumulation\n- **Improved Fault Tolerance**: Better separation of concerns reduces cascade failures\n- **Enhanced Observability**: Rich metadata supports better monitoring and alerting","title":"Benefits - Changelog","ref":"changelog.html#benefits"},{"type":"extras","doc":"","title":"version 0.1.1 (2025.07.13) - Changelog","ref":"changelog.html#version-0-1-1-2025-07-13"},{"type":"extras","doc":"#### Enhanced Architecture\n\n- **Store Registration Centralization**: Moved store registration functionality from `StoreCluster` to dedicated `StoreRegistry` module\n- **Self-Registration**: `StoreRegistry` now automatically registers its own store during initialization when `store_id` is provided\n- **Simplified StoreCluster**: `StoreCluster` now focuses purely on cluster coordination without store registration concerns\n\n#### API Integration\n\n- **ExESDBGater.API Integration**: `list_stores()` function now directly calls `ExESDB.StoreRegistry.list_stores()` instead of maintaining local state\n- **Single Source of Truth**: Store information is now centralized in `StoreRegistry` across the entire system\n- **Improved Error Handling**: Added proper error handling for StoreRegistry calls in GaterAPI\n\n#### System Integration\n\n- **StoreSystem Supervision**: Added `StoreRegistry` to the `StoreSystem` supervisor with proper startup order\n- **Component Isolation**: Each component now has a single, well-defined responsibility\n- **Cleaner State Management**: Removed redundant store state from multiple components\n\n#### Benefits\n\n- **Separation of Concerns**: Clear boundaries between clustering and registration responsibilities\n- **Maintainability**: Easier to maintain and reason about store registration logic\n- **Testability**: Store registration can now be tested in isolation\n- **Reduced Coupling**: Components are less tightly coupled and more modular","title":"StoreRegistry Refactoring - Changelog","ref":"changelog.html#storeregistry-refactoring"},{"type":"extras","doc":"","title":"version 0.0.17 (2025.07.01) - Changelog","ref":"changelog.html#version-0-0-17-2025-07-01"},{"type":"extras","doc":"- `ExESDB` nodes now automatically join the cluster\n- \"Split-Brain\" scenarios are now mitigated","title":"Auto-Clustering - Changelog","ref":"changelog.html#auto-clustering"},{"type":"extras","doc":"- All functionality related to styling is now transferred to the `:bc_utils` package.\n- Added a Banner after startup.\n- Logger filtering for Swarm and LibCluster noise reduction (via BCUtils.LoggerFilters)","title":"BCUtils - Changelog","ref":"changelog.html#bcutils"},{"type":"extras","doc":"#### Features\n\nThe `ExESDB.LoggerFilters` module provides additional log noise reduction specifically for ExESDB's distributed systems components:\n\n- **Ra Consensus Filtering**: Reduces Ra heartbeat, append_entries, pre_vote, request_vote, and routine state transition messages while preserving all errors/warnings\n- **Khepri Database Filtering**: Filters internal Khepri operations (cluster state, store operations) at info/debug levels while maintaining error/warning visibility\n- **Enhanced Swarm Filtering**: Complements BCUtils filtering with additional ExESDB-specific Swarm noise reduction\n- **Enhanced LibCluster Filtering**: Complements BCUtils filtering with additional ExESDB-specific cluster formation noise reduction\n\n#### Benefits\n\n- Dramatically improves log readability in development and production environments\n- Intelligent filtering preserves all error and warning messages\n- Focused on ExESDB-specific distributed systems infrastructure (Ra, Khepri)\n- Works in conjunction with BCUtils.LoggerFilters for comprehensive noise reduction","title":"ExESDB Logger Filtering - Changelog","ref":"changelog.html#exesdb-logger-filtering"},{"type":"extras","doc":"- The `ExESDB.GatewayAPI` is moved to the `:ex_esdb_gater` package.\n\n#### Features\n\nSnapshots Subsystem provides cluster wide support for reading and writing snapshots, using a key derived from the `source_uuid`, `stream_uuid` and `version` of the snapshot.","title":"ExESDBGater - Changelog","ref":"changelog.html#exesdbgater"},{"type":"extras","doc":"","title":"version 0.0.16 (2025.06.26) - Changelog","ref":"changelog.html#version-0-0-16-2025-06-26"},{"type":"extras","doc":"#### Features\n\nSnapshots Subsystem provides cluster wide support for reading and writing snapshots, using a key derived from the `source_uuid`, `stream_uuid` and `version` of the snapshot.\n\n- `record_snapshot/5` function\n- `delete_snapshot/4` function\n- `read_snapshot/4` function\n- `list_snapshots/3` function\n\n#### Supported by Gateway API\n\nIt is advised to use `ExESDB.GatewayAPI` to access the Snapshots Subsystem.","title":"Snapshots - Changelog","ref":"changelog.html#snapshots"},{"type":"extras","doc":"","title":"version 0.0.15 (2025.06.15) - Changelog","ref":"changelog.html#version-0-0-15-2025-06-15"},{"type":"extras","doc":"#### Transient subscriptions\n\n- `:by_stream`, `:by_event_type`, `:by_event_pattern`, `:by_event_payload`\n- Events are forwarded to `Phoenix.PubSub` for now\n\n#### Persistent subscriptions\n\n- `:by_stream`, with support for replaying from a given version\n- Events are forwarded to a specific subscriber process\n- `ack_event/3` function is provided\n\n#### \"Follow-the-Leader\"\n\nEmitter processes are automatically started on the leader node,\nwhen a new leader is elected.\n\n#### Gateway API\n\n- A cluster-wide gateway API is provided\n- is an entry point for all the other modules\n- provides basic High-Availability and Load-Balancing","title":"Subscriptions - Changelog","ref":"changelog.html#subscriptions"},{"type":"extras","doc":"","title":"version 0.0.9-alpha (2025.05.04) - Changelog","ref":"changelog.html#version-0-0-9-alpha-2025-05-04"},{"type":"extras","doc":"- `ExESDB.Subscriptions` module\n- `func_registrations.exs` file\n- emitter trigger in `khepri` now only uses the `erlang`-native :pg library (process groups)\n\n#### Skeleton support for Commanded\n\n- `ExESDB.Commanded.Adapter` module\n- `ExESDB.Commanded.Mapper` module","title":"Subscriptions - Changelog","ref":"changelog.html#subscriptions-1"},{"type":"extras","doc":"","title":"version 0.0.8-alpha - Changelog","ref":"changelog.html#version-0-0-8-alpha"},{"type":"extras","doc":"- Added `ExESDB.EventStore.stream_forward/4` function\n- Added `BeamCampus.ColorFuncs` module\n- Added `ExESDB.Commanded.Adapter` module\n- Refactored `ExESDB.EventStreamReader` and `ExESDB.EventStreamWriter` modules:\n- Streams are now read and written using the `ExESDB.Streams` module\n- Removed `ExESDB.EventStreamReader` module\n- Removed `ExESDB.EventStreamWriter` module","title":"2025.04.13 - Changelog","ref":"changelog.html#2025-04-13"},{"type":"extras","doc":"","title":"version 0.0.7-alpha - Changelog","ref":"changelog.html#version-0-0-7-alpha"},{"type":"extras","doc":"","title":"version 0.0.1-alpha - Changelog","ref":"changelog.html#version-0-0-1-alpha"},{"type":"extras","doc":"- Initial release","title":"2025.03.25 - Changelog","ref":"changelog.html#2025-03-25"},{"type":"extras","doc":"# Getting Started with ExESDB","title":"Getting Started","ref":"getting-started.html"},{"type":"extras","doc":"Event Sourcing with CQRS is a technique for building applications that are based on an immutable log of events, which makes it ideal for building concurrent, distributed systems.\n\nThough it is gaining popularity, the number of options for storing these events is limited and require specialized services like Kurrent (aka Greg's EventStore) or AxonIQ.\n\nOne of the strong-points of the BEAM is, that it comes 'batteries included': there are BEAM-native libraries for many common tasks, like: storage, pub/sub, caching, logging, telemetry, etc.\n\n`ExESDB` is an attempt to create a BEAM-native Event Store written in Erlang/Elixir, building further upon the [Khepri](https://github.com/rabbitmq/khepri) library, which in turn builds upon the [Ra](https://github.com/rabbitmq/ra) library.","title":"Introduction - Getting Started","ref":"getting-started.html#introduction"},{"type":"extras","doc":"**This is a work in progress**\n\nThe project is in an early stage of development, and is not ready for production use.\n\nSource code is available on [GitHub](https://github.com/beam-campus/ex-esdb).","title":"Status - Getting Started","ref":"getting-started.html#status"},{"type":"extras","doc":"In your `mix.exs` file:\n\n```elixir\ndef deps do\n  [\n    {:ex_esdb, \"~> 0.0.16\"}\n  ]\nend\n```","title":"Installation - Getting Started","ref":"getting-started.html#installation"},{"type":"extras","doc":"1. in your `config/config.exs` file:\n\n```elixir\nconfig :ex_esdb, :khepri,\n  # the directory where the khepri store will be created\n  data_dir: \"/data\",\n  # the id of the khepri store.\n  store_id: :ex_esdb_store,\n  # the type of database setup to use\n  db_type: :single,\n  # a global timeout in milliseconds\n  timeout: 10_000,\n  # a list of seed nodes to connect to\n  seed_nodes: [],\n  # the name of the pub/sub module to use\n  pub_sub: :ex_esdb_pub_sub\n\n```\n\n2. from the ENVIRONMENT:\n\n```bash\n\nEX_ESDB_DATA_DIR=\"/data\"\nEX_ESDB_STORE_ID=ex_esdb_store\nEX_ESDB_DB_TYPE=single\nEX_ESDB_TIMEOUT=10000\nEX_ESDB_SEED_NODES=\"\"\nEX_ESDB_PUB_SUB=ex_esdb_pub_sub\n\n```","title":"Configuration - Getting Started","ref":"getting-started.html#configuration"},{"type":"extras","doc":"```elixir\ndefmodule MyApp.Application do\n  use Application\n\n  @impl true\n  def start(_type, _args) do\n    opts = ExESDB.Options.app_env()\n    children = [\n      {ExESDB.System, opts},\n    ]\n\n    opts = [strategy: :one_for_one, name: MyApp.Supervisor]\n    Supervisor.start_link(children, opts)\n  end\n\nend\n```","title":"Usage - Getting Started","ref":"getting-started.html#usage"},{"type":"extras","doc":"# ExESDB Architecture Analysis","title":"Architecture","ref":"architecture.html"},{"type":"extras","doc":"ExESDB is a BEAM-native Event Store built on top of the Khepri library, which in turn is built on the Ra library. It's designed as a distributed, fault-tolerant event sourcing system that leverages the strengths of the BEAM ecosystem for handling concurrent, distributed workloads.","title":"Overview - Architecture","ref":"architecture.html#overview"},{"type":"extras","doc":"```mermaid\ngraph TD\n    A[ExESDB.App] --> B[ExESDB.System]\n    B --> C[PubSub Layer]\n    B --> D[Store Management]\n    B --> E[Cluster Management]\n    B --> F[Event Processing]\n    B --> G[Gateway Layer]\n    \n    D --> D1[StoreManager]\n    D --> D2[Store Workers]\n    D --> D3[Khepri Backend]\n    \n    E --> E1[LibCluster]\n    E --> E2[ClusterSystem]\n    E --> E3[KhepriCluster]\n    E --> E4[LeaderSystem]\n    \n    F --> F1[Streams]\n    F --> F2[Snapshots]\n    F --> F3[Subscriptions]\n    \n    G --> G1[GatewaySupervisor]\n    G --> G2[GatewayWorker]\n```","title":"High-Level Architecture - Architecture","ref":"architecture.html#high-level-architecture"},{"type":"extras","doc":"","title":"Core Components - Architecture","ref":"architecture.html#core-components"},{"type":"extras","doc":"#### ExESDB.App\n- **Purpose**: Main application entry point\n- **Responsibilities**:\n  - Application lifecycle management\n  - Initial configuration loading\n  - Starting the main supervisor tree\n  - Graceful shutdown handling\n\n#### ExESDB.System\n- **Purpose**: Top-level supervisor for the entire system\n- **Responsibilities**:\n  - Supervises all major subsystems\n  - Manages system startup sequence\n  - Handles OS signal processing\n  - Dynamically configures components based on deployment mode (single vs cluster)","title":"1. Application Layer - Architecture","ref":"architecture.html#1-application-layer"},{"type":"extras","doc":"#### ExESDB.StoreManager\n- **Purpose**: Multi-store management and coordination\n- **Responsibilities**:\n  - Dynamic store creation and removal\n  - Store lifecycle management\n  - Configuration management per store\n  - Store status tracking\n\n#### ExESDB.Store\n- **Purpose**: Individual event store wrapper around Khepri\n- **Responsibilities**:\n  - Khepri store initialization\n  - Store state management\n  - Direct interaction with Khepri API\n\n```mermaid\ngraph LR\n    A[StoreManager] --> B[Store1]\n    A --> C[Store2]\n    A --> D[StoreN]\n    \n    B --> E[Khepri Instance 1]\n    C --> F[Khepri Instance 2]\n    D --> G[Khepri Instance N]\n    \n    E --> H[Data Directory 1]\n    F --> I[Data Directory 2]\n    G --> J[Data Directory N]\n```","title":"2. Storage Layer - Architecture","ref":"architecture.html#2-storage-layer"},{"type":"extras","doc":"The clustering layer provides distributed coordination and fault tolerance:\n\n#### ExESDB.KhepriCluster\n- **Purpose**: Khepri-specific cluster coordination\n- **Responsibilities**:\n  - Cluster join/leave operations\n  - Leadership detection and tracking\n  - Membership monitoring\n  - Node health monitoring\n\n#### ExESDB.ClusterSystem\n- **Purpose**: High-level cluster coordination\n- **Responsibilities**:\n  - Supervises cluster coordination components\n  - Manages cluster-specific services\n  - Handles split-brain prevention\n\n#### ExESDB.LeaderSystem\n- **Purpose**: Leadership management\n- **Responsibilities**:\n  - Leader election coordination\n  - Leader-specific functionality activation\n  - Leader state tracking\n\n```mermaid\ngraph TD\n    A[LibCluster] --> B[Node Discovery]\n    B --> C[KhepriCluster]\n    C --> D[Cluster Join/Leave]\n    C --> E[Leadership Detection]\n    C --> F[Membership Monitoring]\n    \n    G[ClusterSystem] --> H[ClusterCoordinator]\n    G --> I[NodeMonitor]\n    \n    J[LeaderSystem] --> K[LeaderWorker]\n    J --> L[LeaderTracker]\n    \n    style A fill:#e1f5fe\n    style G fill:#f3e5f5\n    style J fill:#e8f5e8\n```","title":"3. Clustering Layer - Architecture","ref":"architecture.html#3-clustering-layer"},{"type":"extras","doc":"#### ExESDB.Streams\n- **Purpose**: Event stream management\n- **Responsibilities**:\n  - Stream read/write operations\n  - Stream partitioning via PartitionSupervisor\n  - Worker pool management for stream operations\n\n#### ExESDB.Snapshots\n- **Purpose**: Snapshot management for event sourcing\n- **Responsibilities**:\n  - Snapshot creation and retrieval\n  - Snapshot versioning\n  - Snapshot storage path management\n\n#### ExESDB.Subscriptions\n- **Purpose**: Event subscription management\n- **Responsibilities**:\n  - Subscription lifecycle management\n  - Event delivery to subscribers\n  - Subscription persistence\n\n```mermaid\ngraph TD\n    A[Streams] --> B[StreamsWriters Pool]\n    A --> C[StreamsReaders Pool]\n    \n    D[Snapshots] --> E[SnapshotsWriters Pool]\n    D --> F[SnapshotsReaders Pool]\n    \n    G[Subscriptions] --> H[SubscriptionsReader]\n    G --> I[SubscriptionsWriter]\n    \n    B --> J[DynamicSupervisor]\n    C --> K[DynamicSupervisor]\n    E --> L[DynamicSupervisor]\n    F --> M[DynamicSupervisor]\n    \n    J --> N[StreamWriterWorker1]\n    J --> O[StreamWriterWorker2]\n    K --> P[StreamReaderWorker1]\n    K --> Q[StreamReaderWorker2]\n```","title":"4. Event Processing Layer - Architecture","ref":"architecture.html#4-event-processing-layer"},{"type":"extras","doc":"#### PubSub Integration\n- **Purpose**: Inter-process and inter-node communication\n- **Responsibilities**:\n  - Event broadcasting\n  - Subscription management\n  - Message routing\n\n#### ExESDB.GatewaySupervisor & GatewayWorker\n- **Purpose**: External API gateway\n- **Responsibilities**:\n  - External client request handling\n  - API endpoint management\n  - Request routing to appropriate subsystems","title":"5. Communication Layer - Architecture","ref":"architecture.html#5-communication-layer"},{"type":"extras","doc":"","title":"Architecture Patterns - Architecture","ref":"architecture.html#architecture-patterns"},{"type":"extras","doc":"```mermaid\ngraph TD\n    A[ExESDB.App] --> B[ExESDB.System]\n    B --> C[PubSub]\n    B --> D[StoreManager]\n    B --> E[Streams]\n    B --> F[Snapshots]\n    B --> G[Subscriptions]\n    B --> H[LeaderSystem]\n    B --> I[KhepriCluster]\n    B --> J[GatewaySupervisor]\n    B --> K[ClusterSystem]\n    B --> L[EmitterPools]\n    \n    E --> M[PartitionSupervisor - Writers]\n    E --> N[PartitionSupervisor - Readers]\n    \n    F --> O[PartitionSupervisor - Writers]\n    F --> P[PartitionSupervisor - Readers]\n    \n    H --> Q[LeaderWorker]\n    H --> R[LeaderTracker]\n    \n    K --> S[ClusterCoordinator]\n    K --> T[NodeMonitor]\n    \n    J --> U[GatewayWorker]\n```","title":"1. Supervision Tree Pattern - Architecture","ref":"architecture.html#1-supervision-tree-pattern"},{"type":"extras","doc":"ExESDB extensively uses worker pools for different types of operations:\n\n```mermaid\ngraph LR\n    A[Client Request] --> B[PartitionSupervisor]\n    B --> C[DynamicSupervisor]\n    C --> D[Worker1]\n    C --> E[Worker2]\n    C --> F[WorkerN]\n    \n    G[Hash Ring] --> B\n    H[Load Balancing] --> B\n```","title":"2. Worker Pool Pattern - Architecture","ref":"architecture.html#2-worker-pool-pattern"},{"type":"extras","doc":"```mermaid\nsequenceDiagram\n    participant C as Client\n    participant G as Gateway\n    participant L as Leader\n    participant F as Follower\n    participant K as Khepri\n    \n    C->>G: Write Request\n    G->>L: Route to Leader\n    L->>K: Write to Khepri\n    K->>F: Replicate to Followers\n    F->>K: Acknowledge\n    K->>L: Confirm Write\n    L->>G: Success Response\n    G->>C: Return Result\n```","title":"3. Distributed State Management - Architecture","ref":"architecture.html#3-distributed-state-management"},{"type":"extras","doc":"","title":"Deployment Modes - Architecture","ref":"architecture.html#deployment-modes"},{"type":"extras","doc":"- **Configuration**: `db_type: :single`\n- **Characteristics**:\n  - No clustering components\n  - Local-only operations\n  - Simplified architecture\n  - Development/testing focused","title":"Single Node Mode - Architecture","ref":"architecture.html#single-node-mode"},{"type":"extras","doc":"- **Configuration**: `db_type: :cluster`\n- **Characteristics**:\n  - Full clustering capabilities\n  - Distributed consensus via Ra\n  - Fault tolerance\n  - Production-ready\n\n```mermaid\ngraph TD\n    A[Configuration] --> B{db_type}\n    B -->|:single| C[Single Node Components]\n    B -->|:cluster| D[Cluster Components]\n    \n    C --> E[StoreManager]\n    C --> F[Local Streams]\n    C --> G[Local Snapshots]\n    \n    D --> H[LibCluster]\n    D --> I[ClusterSystem]\n    D --> J[KhepriCluster]\n    D --> K[Distributed Components]\n```","title":"Cluster Mode - Architecture","ref":"architecture.html#cluster-mode"},{"type":"extras","doc":"","title":"Data Flow - Architecture","ref":"architecture.html#data-flow"},{"type":"extras","doc":"```mermaid\nsequenceDiagram\n    participant C as Client\n    participant GW as Gateway\n    participant SM as StoreManager\n    participant S as Store\n    participant K as Khepri\n    participant PS as PubSub\n    \n    C->>GW: Write Event\n    GW->>SM: Route to Store\n    SM->>S: Write Request\n    S->>K: Store Event\n    K->>S: Confirm Write\n    S->>PS: Publish Event\n    PS->>C: Event Notification\n    S->>GW: Success Response\n    GW->>C: Return Result\n```","title":"Event Write Flow - Architecture","ref":"architecture.html#event-write-flow"},{"type":"extras","doc":"```mermaid\nsequenceDiagram\n    participant C as Client\n    participant GW as Gateway\n    participant SR as StreamReader\n    participant S as Store\n    participant K as Khepri\n    \n    C->>GW: Read Stream\n    GW->>SR: Route to Reader\n    SR->>S: Read Request\n    S->>K: Query Events\n    K->>S: Return Events\n    S->>SR: Event Data\n    SR->>GW: Stream Response\n    GW->>C: Return Events\n```","title":"Event Read Flow - Architecture","ref":"architecture.html#event-read-flow"},{"type":"extras","doc":"","title":"Key Design Decisions - Architecture","ref":"architecture.html#key-design-decisions"},{"type":"extras","doc":"- **Rationale**: BEAM-native, Ra-based distributed database\n- **Benefits**: \n  - Native Erlang integration\n  - Built-in clustering\n  - Strong consistency guarantees\n  - Fault tolerance","title":"1. Khepri as Backend - Architecture","ref":"architecture.html#1-khepri-as-backend"},{"type":"extras","doc":"- **Rationale**: Leverages OTP supervision principles\n- **Benefits**:\n  - Fault isolation\n  - Automatic restart strategies\n  - System resilience\n  - Clear responsibility boundaries","title":"2. Supervisor Tree Architecture - Architecture","ref":"architecture.html#2-supervisor-tree-architecture"},{"type":"extras","doc":"- **Rationale**: Efficient concurrent processing\n- **Benefits**:\n  - Load distribution\n  - Resource management\n  - Scalability\n  - Fault tolerance","title":"3. Worker Pool Pattern - Architecture","ref":"architecture.html#3-worker-pool-pattern"},{"type":"extras","doc":"- **Rationale**: Support for multiple event stores in single cluster\n- **Benefits**:\n  - Tenant isolation\n  - Resource optimization\n  - Flexible deployment\n  - Gradual migration support","title":"4. Multi-Store Architecture - Architecture","ref":"architecture.html#4-multi-store-architecture"},{"type":"extras","doc":"","title":"Performance Considerations - Architecture","ref":"architecture.html#performance-considerations"},{"type":"extras","doc":"- Uses PartitionSupervisor for distributing workload\n- Hash-based routing for even distribution\n- Separate pools for read/write operations","title":"Partitioning Strategy - Architecture","ref":"architecture.html#partitioning-strategy"},{"type":"extras","doc":"- Configurable probe intervals for node monitoring\n- Failure thresholds to prevent cascade failures\n- Efficient membership change detection","title":"Clustering Optimization - Architecture","ref":"architecture.html#clustering-optimization"},{"type":"extras","doc":"- Dynamic worker creation/destruction\n- Configurable timeout values\n- Memory-efficient event storage via Khepri","title":"Resource Management - Architecture","ref":"architecture.html#resource-management"},{"type":"extras","doc":"","title":"Security Considerations - Architecture","ref":"architecture.html#security-considerations"},{"type":"extras","doc":"- Node-to-node communication via Erlang distribution\n- Cluster authentication via shared secrets\n- Network partitioning detection and handling","title":"Network Security - Architecture","ref":"architecture.html#network-security"},{"type":"extras","doc":"- Gateway-based request filtering\n- Store-level access control\n- Subscription-based permissions","title":"Access Control - Architecture","ref":"architecture.html#access-control"},{"type":"extras","doc":"","title":"Monitoring and Observability - Architecture","ref":"architecture.html#monitoring-and-observability"},{"type":"extras","doc":"- Built-in metrics module\n- Performance monitoring\n- Cluster health tracking","title":"Metrics Collection - Architecture","ref":"architecture.html#metrics-collection"},{"type":"extras","doc":"- Structured logging throughout\n- Configurable log levels\n- Cluster-aware log correlation","title":"Logging Strategy - Architecture","ref":"architecture.html#logging-strategy"},{"type":"extras","doc":"- Node health monitoring\n- Store availability checks\n- Leadership status tracking","title":"Health Checks - Architecture","ref":"architecture.html#health-checks"},{"type":"extras","doc":"","title":"Scalability Patterns - Architecture","ref":"architecture.html#scalability-patterns"},{"type":"extras","doc":"- Add nodes to existing cluster\n- Automatic workload redistribution\n- Leader election for coordination","title":"Horizontal Scaling - Architecture","ref":"architecture.html#horizontal-scaling"},{"type":"extras","doc":"- Worker pool sizing\n- Memory allocation tuning\n- Timeout configuration\n\nThis architecture provides a solid foundation for building distributed, fault-tolerant event sourcing systems while leveraging the unique strengths of the BEAM ecosystem.","title":"Vertical Scaling - Architecture","ref":"architecture.html#vertical-scaling"},{"type":"extras","doc":"","title":"Testing","ref":"testing.html"},{"type":"extras","doc":"# Failure Handling in ExESDB\n\nThis guide provides a comprehensive overview of all failure handling strategies implemented in ExESDB, from individual process failures to cluster-wide outages. ExESDB is built on the BEAM's \"let it crash\" philosophy while providing robust recovery mechanisms at every level.","title":"Failure Handling","ref":"failure-handling.html"},{"type":"extras","doc":"1. [Failure Categories](#failure-categories)\n2. [Supervision Strategies](#supervision-strategies)\n3. [Node-Level Failures](#node-level-failures)\n4. [Network Partitions](#network-partitions)\n5. [Data Consistency](#data-consistency)\n6. [Worker Process Failures](#worker-process-failures)\n7. [Storage Failures](#storage-failures)\n8. [Configuration and Monitoring](#configuration-and-monitoring)\n9. [Recovery Procedures](#recovery-procedures)\n10. [Testing Failure Scenarios](#testing-failure-scenarios)","title":"Table of Contents - Failure Handling","ref":"failure-handling.html#table-of-contents"},{"type":"extras","doc":"ExESDB handles failures across multiple dimensions:","title":"Failure Categories - Failure Handling","ref":"failure-handling.html#failure-categories"},{"type":"extras","doc":"- **Worker crashes**: Individual GenServer processes failing\n- **Supervisor crashes**: Supervisor trees failing\n- **Application crashes**: Entire OTP applications going down","title":"1. Process-Level Failures - Failure Handling","ref":"failure-handling.html#1-process-level-failures"},{"type":"extras","doc":"- **Hard crashes**: Sudden node termination (power loss, kill -9)\n- **Soft crashes**: Graceful shutdowns and restarts\n- **Network isolation**: Node becomes unreachable but continues running","title":"2. Node-Level Failures - Failure Handling","ref":"failure-handling.html#2-node-level-failures"},{"type":"extras","doc":"- **Split-brain scenarios**: Network partitions causing multiple leaders\n- **Quorum loss**: Insufficient nodes for consensus\n- **Data corruption**: Storage-level integrity issues","title":"3. Cluster-Level Failures - Failure Handling","ref":"failure-handling.html#3-cluster-level-failures"},{"type":"extras","doc":"- **Disk failures**: Storage becoming unavailable\n- **Corruption**: Data integrity violations\n- **Performance degradation**: Slow storage affecting operations","title":"4. Storage-Level Failures - Failure Handling","ref":"failure-handling.html#4-storage-level-failures"},{"type":"extras","doc":"ExESDB uses a hierarchical supervision tree with different restart strategies for different components:","title":"Supervision Strategies - Failure Handling","ref":"failure-handling.html#supervision-strategies"},{"type":"extras","doc":"```\nExESDB.App (one_for_one)\n└── ExESDB.System (one_for_one)\n    ├── Phoenix.PubSub\n    ├── Cluster.Supervisor (LibCluster)\n    ├── PartitionSupervisor (EmitterPools)\n    ├── ExESDB.Store\n    ├── ExESDB.ClusterSystem (one_for_one)\n    ├── ExESDB.Streams (one_for_one)\n    ├── ExESDB.Snapshots\n    ├── ExESDB.Subscriptions (one_for_one)\n    ├── ExESDB.GatewaySupervisor (one_for_one)\n    └── ExESDB.LeaderSystem (one_for_one)\n```","title":"Root Supervision Tree - Failure Handling","ref":"failure-handling.html#root-supervision-tree"},{"type":"extras","doc":"| Component | Strategy | Restart | Reason |\n|-----------|----------|---------|--------|\n| **System** | `:one_for_one` | `:permanent` | Core system components |\n| **ClusterSystem** | `:one_for_one` | `:permanent` | Independent cluster services |\n| **Streams** | `:one_for_one` | `:permanent` | Stream readers/writers are independent |\n| **GatewaySupervisor** | `:one_for_one` | `:permanent` | Gateway API and workers |\n| **StreamsWriterWorker** | `:temporary` | `:temporary` | TTL-based lifecycle |\n| **StreamsReaderWorker** | `:temporary` | `:temporary` | On-demand workers |\n| **GatewayWorker** | `:permanent` | `:permanent` | Core gateway functionality |","title":"Restart Strategies by Component - Failure Handling","ref":"failure-handling.html#restart-strategies-by-component"},{"type":"extras","doc":"**Stream Workers**:\n- Use `:temporary` restart to prevent infinite restart loops\n- Implement TTL-based shutdown for resource management\n- Automatically clean up Swarm registrations on exit\n\n**Gateway Workers**:\n- Use `:permanent` restart for high availability\n- Register with Swarm for distributed load balancing\n- Handle graceful shutdown with cleanup","title":"Worker Lifecycle Management - Failure Handling","ref":"failure-handling.html#worker-lifecycle-management"},{"type":"extras","doc":"","title":"Node-Level Failures - Failure Handling","ref":"failure-handling.html#node-level-failures"},{"type":"extras","doc":"When a node crashes unexpectedly, multiple systems work together to detect and recover:\n\n#### 1. NodeMonitor Service (Fast Detection)\n\n**Problem**: Traditional Raft consensus timeouts can take 10-30 seconds\n**Solution**: Proactive health monitoring with 6-second detection\n\nThis solution implements a comprehensive approach to quickly detect and handle node failures:","title":"Hard Crash Detection and Recovery - Failure Handling","ref":"failure-handling.html#hard-crash-detection-and-recovery"},{"type":"extras","doc":"**Location**: `lib/ex_esdb/node_monitor.ex`\n\n**Features**:\n- **Active Health Probing**: Probes cluster nodes every 2 seconds\n- **Multi-Layer Health Checks**: Verifies node connectivity + application health\n- **Fast Failure Detection**: Marks nodes as failed after 3 consecutive probe failures (6 seconds total)\n- **Automatic Cleanup**: Removes stale Swarm registrations from failed nodes\n- **Event-Driven Updates**: Responds to `:nodeup`/`:nodedown` events\n\n**Configuration**:\n```elixir\n# Default settings (configurable)\nprobe_interval: 2_000,     # 2 seconds between probes\nfailure_threshold: 3,      # 3 failures = node considered down\nprobe_timeout: 1_000       # 1 second timeout per probe\n```","title":"1. NodeMonitor Service - Failure Handling","ref":"failure-handling.html#1-nodemonitor-service"},{"type":"extras","doc":"The NodeMonitor integrates seamlessly with your current LibCluster setup:\n\n**Modified Files**:\n- `lib/ex_esdb/cluster_system.ex` - Added NodeMonitor to supervision tree\n- Uses existing `ClusterCoordinator` for split-brain prevention\n- Leverages current `Swarm` registrations for worker cleanup","title":"2. Integration with Existing Architecture - Failure Handling","ref":"failure-handling.html#2-integration-with-existing-architecture"},{"type":"extras","doc":"#### Health Probe Cycle (Every 2 seconds):\n1. **Discover Nodes**: Get cluster members from Khepri\n2. **Probe Health**: Test each node with RPC calls\n3. **Track Failures**: Increment failure count for unresponsive nodes\n4. **Trigger Cleanup**: Handle nodes that exceed failure threshold\n5. **Update State**: Maintain monitoring state for next cycle\n\n#### Failure Detection:\n```elixir\n# Multi-layer health check\n1. Node connectivity: :rpc.call(node, :erlang, :node, [])\n2. Application health: Check if :ex_esdb is running\n3. Failure tracking: 3 consecutive failures = node down\n```\n\n#### Automatic Cleanup:\n```elixir\n# When a node is detected as failed:\n1. Remove Swarm worker registrations from failed node\n2. Update cluster state (notify other components)\n3. Clean up subscriptions tied to failed node\n4. Log failure for monitoring/alerting\n```","title":"3. How It Works - Failure Handling","ref":"failure-handling.html#3-how-it-works"},{"type":"extras","doc":"**Fast Detection**: \n- Traditional Raft consensus timeout: 10-30 seconds\n- This solution: 6 seconds (3 failures × 2 second intervals)\n\n**Proactive Cleanup**:\n- Prevents requests to unavailable workers\n- Maintains cluster integrity\n- Enables faster recovery\n\n**Graceful Degradation**:\n- System continues operating with remaining nodes\n- Workers redistribute automatically via Swarm\n- No single point of failure","title":"4. Benefits - Failure Handling","ref":"failure-handling.html#4-benefits"},{"type":"extras","doc":"#### Check Cluster Health:\n```elixir\n# Get current health status\nExESDB.NodeMonitor.health_status()\n# Returns: %{\n#   monitored_nodes: [:node1@host, :node2@host],\n#   node_failures: %{},\n#   last_seen: %{:node1@host => 1625567890123},\n#   threshold: 3\n# }\n```\n\n#### Manual Node Probe:\n```elixir\n# Force probe a specific node\nExESDB.NodeMonitor.probe_node(:node1@host)\n# Returns: :healthy or :unhealthy\n```","title":"5. Usage - Failure Handling","ref":"failure-handling.html#5-usage"},{"type":"extras","doc":"**Environment Variables** (can be added to your config):\n```elixir\nconfig :ex_esdb, :node_monitor,\n  probe_interval: 2_000,      # How often to probe (ms)\n  failure_threshold: 3,       # Failures before marking as down\n  probe_timeout: 1_000,       # Timeout per probe (ms)\n  cleanup_stale_workers: true # Auto-cleanup Swarm registrations\n```","title":"6. Configuration Options - Failure Handling","ref":"failure-handling.html#6-configuration-options"},{"type":"extras","doc":"**Log Messages**:\n- `NodeMonitor started with 2000ms intervals`\n- `Health probe failed for node1@host (2/3)`\n- `Node node1@host detected as failed, initiating cleanup`\n- `Cleaning up Swarm registration: {:gateway_worker, node1@host, 1234}`\n\n**Integration Points**:\n- Logs can be forwarded to your monitoring system\n- Health status can be exposed via HTTP endpoints\n- Alerts can be triggered on node failures","title":"7. Monitoring and Observability - Failure Handling","ref":"failure-handling.html#7-monitoring-and-observability"},{"type":"extras","doc":"The solution is designed to be extensible:\n\n**Planned Enhancements**:\n- **Forced Khepri Node Removal**: Actively remove failed nodes from consensus\n- **Worker Redistribution**: Trigger immediate rebalancing of Swarm workers\n- **Leader Election**: Handle leader failures more aggressively\n- **Custom Health Checks**: Application-specific health validation","title":"8. Advanced Features (Future Extensions) - Failure Handling","ref":"failure-handling.html#8-advanced-features-future-extensions"},{"type":"extras","doc":"**No Breaking Changes**: \n- Fully backward compatible with existing cluster\n- Can be deployed incrementally (node by node)\n- Falls back gracefully if monitoring fails\n\n**Resource Usage**:\n- Minimal CPU overhead (RPC calls every 2 seconds)\n- Low memory footprint (tracks failure state only)\n- Network traffic: ~1KB per node per probe","title":"9. Deployment - Failure Handling","ref":"failure-handling.html#9-deployment"},{"type":"extras","doc":"**Chaos Engineering**:\n```bash\n# Simulate hard crash\ndocker kill ex-esdb-node1\n\n# Monitor logs for detection\ndocker logs ex-esdb-node2 | grep NodeMonitor\n\n# Verify cleanup\n# Should see Swarm registrations removed within 6 seconds\n```\n\n**Expected Timeline**:\n- T+0: Node crashes\n- T+2s: First probe failure detected\n- T+4s: Second probe failure  \n- T+6s: Third probe failure, node marked as failed\n- T+6s: Cleanup initiated (Swarm registrations removed)\n- T+8s: Next probe cycle (failed node no longer monitored)\n\n#### 2. LibCluster Integration\n\n**Built-in Node Detection**:\n- Uses `:net_kernel.monitor_nodes(true, [:nodedown_reason])` for immediate notification\n- Gossip-based discovery helps detect network issues\n- Automatic cluster formation and healing\n\n#### 3. ClusterCoordinator\n\n**Split-Brain Prevention**:\n- Deterministic leader election (lowest node name)\n- Prevents multiple clusters from forming\n- Coordinates safe cluster joining\n\n**Features**:\n```elixir\n# Prevent split-brain during network partitions\ndef should_be_cluster_coordinator(connected_nodes) do\n  all_nodes = [node() | connected_nodes] |> Enum.sort()\n  node() == List.first(all_nodes)\nend\n```","title":"10. Testing the Solution - Failure Handling","ref":"failure-handling.html#10-testing-the-solution"},{"type":"extras","doc":"ExESDB handles graceful shutdowns through multiple mechanisms:\n\n**Signal Handling**:\n```elixir\n# SIGTERM and SIGQUIT handling\n:os.set_signal(:sigterm, :handle)\n:os.set_signal(:sigquit, :handle)\n```\n\n**Process Cleanup**:\n- Workers unregister from Swarm before termination\n- Subscription state is persisted\n- Transactions are completed or rolled back","title":"Graceful Shutdown Handling - Failure Handling","ref":"failure-handling.html#graceful-shutdown-handling"},{"type":"extras","doc":"","title":"Network Partitions - Failure Handling","ref":"failure-handling.html#network-partitions"},{"type":"extras","doc":"ExESDB implements multiple layers to prevent split-brain scenarios:\n\n#### 1. ClusterCoordinator Logic\n- **Deterministic Election**: Uses sorted node names for consistent leader selection\n- **Existing Cluster Detection**: Searches for active clusters before forming new ones\n- **Coordinated Joining**: Prevents multiple simultaneous cluster formations\n\n#### 2. Raft Consensus (Ra/Khepri)\n- **Majority Quorum**: Requires majority of nodes for write operations\n- **Leader Election**: Automatic failover when leader becomes unavailable\n- **Log Replication**: Ensures consistency across cluster members\n\n#### 3. Partition Tolerance\n**Minority Partition Behavior**:\n- Nodes in minority partition become read-only\n- No new events can be written without quorum\n- Automatic healing when partition resolves\n\n**Majority Partition Behavior**:\n- Continues normal operations\n- Elects new leader if needed\n- Accepts new writes and maintains consistency","title":"Split-Brain Prevention - Failure Handling","ref":"failure-handling.html#split-brain-prevention"},{"type":"extras","doc":"**Automatic Healing Process**:\n1. **Detection**: Nodes detect network connectivity restoration\n2. **State Synchronization**: Minority nodes sync with majority\n3. **Conflict Resolution**: Raft log reconciliation\n4. **Service Restoration**: Workers redistribute across all nodes","title":"Network Partition Recovery - Failure Handling","ref":"failure-handling.html#network-partition-recovery"},{"type":"extras","doc":"","title":"Data Consistency - Failure Handling","ref":"failure-handling.html#data-consistency"},{"type":"extras","doc":"ExESDB provides ACID guarantees through Khepri transactions:\n\n**Optimistic Concurrency Control**:\n```elixir\ndef try_append_events(store, stream_id, expected_version, events) do\n  current_version = get_current_version(store, stream_id)\n  \n  if current_version == expected_version do\n    # Proceed with append\n    append_events_atomically(store, stream_id, events, current_version)\n  else\n    {:error, :wrong_expected_version}\n  end\nend\n```\n\n**Transaction Isolation**:\n- Uses Khepri's MVCC for concurrent access\n- Transactions are atomic and isolated\n- Automatic rollback on failures","title":"Transaction Handling - Failure Handling","ref":"failure-handling.html#transaction-handling"},{"type":"extras","doc":"**Version Conflicts**:\n- Expected version mismatches return `:wrong_expected_version`\n- Clients must retry with updated expected version\n- No automatic conflict resolution (explicit client handling)\n\n**Concurrent Writes**:\n- Only one writer per stream at a time\n- Serialized access through stream-specific workers\n- Queue management for high-throughput scenarios","title":"Conflict Resolution - Failure Handling","ref":"failure-handling.html#conflict-resolution"},{"type":"extras","doc":"","title":"Worker Process Failures - Failure Handling","ref":"failure-handling.html#worker-process-failures"},{"type":"extras","doc":"#### Writers (StreamsWriterWorker)\n**Lifecycle Management**:\n- `:temporary` restart strategy prevents restart loops\n- TTL-based shutdown for resource management\n- Automatic Swarm cleanup on termination\n\n**Failure Scenarios**:\n```elixir\n# TTL-based shutdown\ndef handle_info(:check_idle, %{idle_since: idle_since} = state) do\n  writer_ttl = Options.writer_idle_ms()\n  \n  if idle_since + writer_ttl < epoch_time_ms() do\n    Process.exit(self(), :ttl_reached)\n  end\n  \n  {:noreply, state}\nend\n\n# Graceful cleanup on exit\ndef handle_info({:EXIT, _pid, reason}, %{worker_name: name} = state) do\n  Swarm.unregister_name(name)\n  {:noreply, state}\nend\n```\n\n#### Readers (StreamsReaderWorker)\n- Similar TTL-based lifecycle\n- On-demand creation for read operations\n- Automatic cleanup when no longer needed","title":"Stream Worker Failure Handling - Failure Handling","ref":"failure-handling.html#stream-worker-failure-handling"},{"type":"extras","doc":"**High Availability Design**:\n- `:permanent` restart strategy for critical gateway functions\n- Load balancing through random worker selection\n- Graceful failover to other gateway workers\n\n**Worker Distribution**:\n```elixir\n# Random load balancing with fallback\ndefp random_gateway_worker do\n  case Swarm.members(:gateway_workers) do\n    [] -> \n      # Fallback to local gateway if no distributed workers\n      ExESDB.GatewayWorker\n    workers -> \n      workers |> Enum.random() |> elem(1)\n  end\nend\n```","title":"Gateway Worker Failures - Failure Handling","ref":"failure-handling.html#gateway-worker-failures"},{"type":"extras","doc":"**\"Follow-the-Leader\" Pattern**:\n- Subscription workers automatically migrate to leader node\n- Persistent subscription state survives worker failures\n- Automatic restart and state recovery","title":"Subscription Worker Failures - Failure Handling","ref":"failure-handling.html#subscription-worker-failures"},{"type":"extras","doc":"","title":"Storage Failures - Failure Handling","ref":"failure-handling.html#storage-failures"},{"type":"extras","doc":"**Data Directory Management**:\n```elixir\n# Configurable data directory\nconfig :ex_esdb, :khepri,\n  data_dir: \"/data\",\n  store_id: :reg_gh,\n  timeout: 2_000\n```\n\n**Failure Scenarios**:\n\n#### Disk Space Exhaustion\n- **Detection**: Monitor disk usage in production\n- **Mitigation**: Implement log compaction and cleanup\n- **Recovery**: Restore from snapshots if available\n\n#### Corruption Detection\n- **Checksums**: Ra maintains data integrity checks\n- **Verification**: Periodic consistency checks\n- **Recovery**: Restore from cluster peers or backups\n\n#### Performance Degradation\n- **Monitoring**: Track operation latencies\n- **Alerting**: Set thresholds for response times\n- **Mitigation**: Scale storage or redistribute load","title":"Khepri/Ra Storage Resilience - Failure Handling","ref":"failure-handling.html#khepri-ra-storage-resilience"},{"type":"extras","doc":"**Snapshot Management**:\n- Regular snapshots of aggregate state\n- Version-based snapshot storage\n- Distributed snapshot replication\n\n**Disaster Recovery**:\n1. **Data Loss Prevention**: Multi-node replication\n2. **Point-in-Time Recovery**: Event replay from snapshots\n3. **Cross-Region Backup**: External backup strategies","title":"Backup and Recovery - Failure Handling","ref":"failure-handling.html#backup-and-recovery"},{"type":"extras","doc":"","title":"Configuration and Monitoring - Failure Handling","ref":"failure-handling.html#configuration-and-monitoring"},{"type":"extras","doc":"**Cluster Health**:\n```elixir\n# Check overall cluster status\nExESDB.NodeMonitor.health_status()\n\n# Check specific node\nExESDB.NodeMonitor.probe_node(:node1@host)\n\n# Get cluster members\nExESDB.Cluster.members(store_id)\n```\n\n**Performance Metrics**:\n- Operation latencies\n- Throughput measurements\n- Resource utilization\n- Error rates","title":"Health Check Endpoints - Failure Handling","ref":"failure-handling.html#health-check-endpoints"},{"type":"extras","doc":"**Structured Logging**:\n```elixir\nconfig :logger, :console,\n  format: \"$time $metadata[$level] $message\\n\",\n  metadata: [:mfa]\n```\n\n**Alert Categories**:\n- **Critical**: Node failures, data corruption\n- **Warning**: Performance degradation, high error rates\n- **Info**: Normal operations, state changes","title":"Logging and Alerting - Failure Handling","ref":"failure-handling.html#logging-and-alerting"},{"type":"extras","doc":"**Production Settings**:\n```elixir\n# Timeouts\nconfig :ex_esdb, :khepri,\n  timeout: 5_000  # Increase for production\n\n# Node monitoring\nconfig :ex_esdb, :node_monitor,\n  probe_interval: 2_000,\n  failure_threshold: 3,\n  probe_timeout: 1_000\n\n# Worker TTL\nconfig :ex_esdb, :worker_idle_ms, 300_000  # 5 minutes\n```\n\n**Development Settings**:\n```elixir\n# Faster timeouts for development\nconfig :ex_esdb, :khepri,\n  timeout: 10_000\n\n# Shorter TTL for resource management\nconfig :ex_esdb, :worker_idle_ms, 60_000  # 1 minute\n```","title":"Configuration Best Practices - Failure Handling","ref":"failure-handling.html#configuration-best-practices"},{"type":"extras","doc":"","title":"Recovery Procedures - Failure Handling","ref":"failure-handling.html#recovery-procedures"},{"type":"extras","doc":"#### Single Node Recovery\n1. **Identify Issue**: Check logs and monitoring\n2. **Isolate Node**: Remove from load balancer if needed\n3. **Restart Service**: Use graceful restart procedures\n4. **Verify Health**: Confirm cluster membership\n5. **Restore Traffic**: Gradually return to service\n\n#### Cluster Recovery\n1. **Assess Damage**: Determine scope of failure\n2. **Quorum Check**: Ensure majority of nodes available\n3. **Leader Election**: Verify or trigger new leader election\n4. **Data Integrity**: Check for any corruption\n5. **Service Validation**: Test critical operations","title":"Manual Recovery Steps - Failure Handling","ref":"failure-handling.html#manual-recovery-steps"},{"type":"extras","doc":"**Self-Healing Mechanisms**:\n- Automatic process restarts via supervision\n- Worker redistribution through Swarm\n- Cluster reformation after partitions\n- Leader election on failures\n\n**Monitoring Integration**:\n- Health check failures trigger alerts\n- Automatic scaling based on load\n- Proactive maintenance scheduling","title":"Automated Recovery - Failure Handling","ref":"failure-handling.html#automated-recovery"},{"type":"extras","doc":"","title":"Testing Failure Scenarios - Failure Handling","ref":"failure-handling.html#testing-failure-scenarios"},{"type":"extras","doc":"**Node Failures**:\n```bash\n# Hard crash simulation\ndocker kill ex-esdb-node1\n\n# Network partition simulation\niptables -A INPUT -s   -j DROP\niptables -A OUTPUT -d   -j DROP\n\n# Resource exhaustion\nstress --cpu 8 --io 4 --vm 2 --vm-bytes 128M --timeout 60s\n```\n\n**Service Failures**:\n```bash\n# Stop specific services\nsystemctl stop ex_esdb\n\n# Simulate disk failures\nfill-disk.sh /data 95%\n\n# Network latency injection\ntc qdisc add dev eth0 root netem delay 500ms\n```","title":"Chaos Engineering - Failure Handling","ref":"failure-handling.html#chaos-engineering"},{"type":"extras","doc":"#### Scenario 1: Single Node Failure\n**Steps**:\n1. Start 3-node cluster\n2. Kill one node abruptly\n3. Verify cluster continues operating\n4. Check client request success rates\n5. Restart failed node\n6. Verify automatic rejoin\n\n**Expected Results**:\n- Cluster maintains quorum (2/3 nodes)\n- No data loss\n- Client operations continue\n- Failed node rejoins automatically\n\n#### Scenario 2: Network Partition\n**Steps**:\n1. Start 3-node cluster\n2. Create network partition (2 vs 1 node)\n3. Verify majority partition continues\n4. Check minority partition becomes read-only\n5. Heal partition\n6. Verify automatic reconciliation\n\n**Expected Results**:\n- Majority partition elects new leader\n- Minority partition rejects writes\n- Healing triggers state synchronization\n- No data inconsistencies\n\n#### Scenario 3: Leader Failure\n**Steps**:\n1. Identify current leader\n2. Kill leader node\n3. Verify new leader election\n4. Check subscription migration\n5. Validate continued operations\n\n**Expected Results**:\n- New leader elected within timeout\n- Subscriptions migrate to new leader\n- Client operations resume\n- Worker redistribution occurs","title":"Test Scenarios - Failure Handling","ref":"failure-handling.html#test-scenarios"},{"type":"extras","doc":"**Key Metrics**:\n- Response times\n- Error rates\n- Memory usage\n- CPU utilization\n- Network connectivity\n- Disk I/O\n\n**Log Analysis**:\n```bash\n# Monitor cluster events\ndocker logs -f ex-esdb-node1 | grep -E \"(NodeMonitor|Cluster|Leader)\"\n\n# Check for errors\ndocker logs ex-esdb-node1 | grep -i error\n\n# Monitor worker redistribution\ndocker logs ex-esdb-node1 | grep -i swarm\n```","title":"Monitoring During Tests - Failure Handling","ref":"failure-handling.html#monitoring-during-tests"},{"type":"extras","doc":"ExESDB provides comprehensive failure handling across all system levels, from individual process failures to cluster-wide outages. The system is designed with the BEAM's \"let it crash\" philosophy while ensuring data consistency and high availability through:\n\n**Key Strengths**:\n- **Fast Failure Detection**: 6-second node failure detection vs 10-30 second consensus timeouts\n- **Automatic Recovery**: Self-healing mechanisms at every level\n- **Data Consistency**: ACID guarantees through Raft consensus\n- **High Availability**: No single points of failure\n- **Graceful Degradation**: System continues operating with reduced capacity\n\n**Operational Benefits**:\n- **Reduced Downtime**: Automatic failover and recovery\n- **Operational Simplicity**: Minimal manual intervention required\n- **Predictable Behavior**: Well-defined failure modes and recovery procedures\n- **Monitoring Integration**: Comprehensive observability and alerting\n\n**Production Readiness**:\n- Battle-tested BEAM supervision principles\n- Proven Raft consensus implementation (Ra)\n- Comprehensive testing scenarios\n- Clear operational procedures\n\nThis failure handling strategy ensures that ExESDB can operate reliably in production environments while maintaining the flexibility and resilience that makes BEAM-based systems ideal for distributed, fault-tolerant applications.","title":"Conclusion - Failure Handling","ref":"failure-handling.html#conclusion"},{"type":"extras","doc":"# Logger Filtering in ExESDB Event Store\n\nExESDB is built on top of several distributed systems components that can generate significant amounts of log noise during normal operation. To provide a better developer experience and cleaner production logs, ExESDB implements a comprehensive logger filtering system.","title":"Logger Filtering","ref":"logger-filtering.html"},{"type":"extras","doc":"ExESDB uses a two-tier approach to logger filtering:\n\n1. **BCUtils.LoggerFilters** - Provides general-purpose filtering for common BEAM distributed systems\n2. **ExESDB.LoggerFilters** - Provides specialized filtering for ExESDB's core infrastructure components\n\nThis layered approach ensures comprehensive noise reduction while maintaining full visibility into errors and warnings.","title":"Overview - Logger Filtering","ref":"logger-filtering.html#overview"},{"type":"extras","doc":"BCUtils provides foundational logger filtering for commonly used distributed systems libraries:","title":"BCUtils Logger Filtering - Logger Filtering","ref":"logger-filtering.html#bcutils-logger-filtering"},{"type":"extras","doc":"- Filters routine process registration/unregistration messages\n- Reduces noise from node up/down events\n- Maintains visibility into registry errors and conflicts","title":"Swarm Process Registry - Logger Filtering","ref":"logger-filtering.html#swarm-process-registry"},{"type":"extras","doc":"- Filters cluster formation and gossip protocol messages\n- Reduces connection/disconnection event noise\n- Preserves cluster formation failures and split-brain warnings","title":"LibCluster Auto-Clustering - Logger Filtering","ref":"logger-filtering.html#libcluster-auto-clustering"},{"type":"extras","doc":"ExESDB extends the filtering capabilities with specialized filters for its core infrastructure:","title":"ExESDB Logger Filtering - Logger Filtering","ref":"logger-filtering.html#exesdb-logger-filtering"},{"type":"extras","doc":"The Ra consensus library is fundamental to ExESDB's distributed operation but generates substantial log noise during normal consensus operations.\n\n**Filtered Messages:**\n- Heartbeat messages between Ra nodes\n- `append_entries` consensus protocol messages\n- `pre_vote` and `request_vote` election messages\n- Routine state transitions (follower ↔ candidate ↔ leader)\n- Internal Ra module operations at info/debug levels\n\n**Preserved Messages:**\n- All error and warning level messages\n- Election failures and split-brain scenarios\n- Consensus failures and recovery operations","title":"Ra Consensus Library Filtering - Logger Filtering","ref":"logger-filtering.html#ra-consensus-library-filtering"},{"type":"extras","doc":"Khepri serves as ExESDB's distributed database backend and can be verbose about internal operations.\n\n**Filtered Messages:**\n- Cluster state synchronization messages\n- Store operation confirmations\n- Routine cluster member coordination\n- Internal Khepri module operations at info/debug levels\n\n**Preserved Messages:**\n- Database errors and transaction failures\n- Cluster coordination problems\n- Data consistency warnings","title":"Khepri Database Filtering - Logger Filtering","ref":"logger-filtering.html#khepri-database-filtering"},{"type":"extras","doc":"ExESDB provides additional filtering beyond BCUtils for ExESDB-specific use cases:\n\n**Enhanced Swarm Filtering:**\n- ExESDB-specific process registry patterns\n- Stream coordinator registration/unregistration\n- Event emitter lifecycle messages\n\n**Enhanced LibCluster Filtering:**\n- ExESDB cluster topology changes\n- Node role transitions (leader/follower)\n- Gateway API cluster coordination","title":"Enhanced Swarm & LibCluster Filtering - Logger Filtering","ref":"logger-filtering.html#enhanced-swarm-libcluster-filtering"},{"type":"extras","doc":"","title":"Configuration - Logger Filtering","ref":"logger-filtering.html#configuration"},{"type":"extras","doc":"In development, you may want to see more detailed logs. Configure your logger in `config/dev.exs`:\n\n```elixir\n# Minimal filtering - see more activity\nconfig :logger, :console,\n  level: :debug,\n  format: \"[$level] $message\\n\"\n\n# Apply only critical noise reduction\nconfig :logger, \n  backends: [:console],\n  compile_time_purge_matching: [\n    [level_lower_than: :info]\n  ]\n```","title":"Development Environment - Logger Filtering","ref":"logger-filtering.html#development-environment"},{"type":"extras","doc":"For production, apply comprehensive filtering in `config/prod.exs`:\n\n```elixir\n# Apply all ExESDB logger filters\nconfig :logger,\n  backends: [:console],\n  compile_time_purge_matching: [\n    [level_lower_than: :info]\n  ]\n\n# Add custom filters\nconfig :logger, :console,\n  level: :info,\n  format: \"[$level] $message\\n\",\n  metadata_filter: [\n    {ExESDB.LoggerFilters, :filter_ra},\n    {ExESDB.LoggerFilters, :filter_khepri},\n    {ExESDB.LoggerFilters, :filter_swarm},\n    {ExESDB.LoggerFilters, :filter_libcluster}\n  ]\n```","title":"Production Environment - Logger Filtering","ref":"logger-filtering.html#production-environment"},{"type":"extras","doc":"You can extend the filtering system for your specific needs:\n\n```elixir\ndefmodule MyApp.CustomLoggerFilters do\n  def filter_my_component(log_event) do\n    case log_event do\n      {level, _gl, {Logger, msg, _ts, metadata}} ->\n        if should_filter_my_component?(level, msg, metadata) do\n          :stop\n        else\n          :ignore\n        end\n      _ ->\n        :ignore\n    end\n  end\n\n  defp should_filter_my_component?(level, msg, metadata) do\n    # Your custom filtering logic\n    level in [:info, :debug] and routine_operation?(msg)\n  end\nend\n```","title":"Custom Filtering - Logger Filtering","ref":"logger-filtering.html#custom-filtering"},{"type":"extras","doc":"","title":"Best Practices - Logger Filtering","ref":"logger-filtering.html#best-practices"},{"type":"extras","doc":"Always ensure that error and warning messages are never filtered. The ExESDB filters follow this principle religiously.","title":"1. Preserve Error Visibility - Logger Filtering","ref":"logger-filtering.html#1-preserve-error-visibility"},{"type":"extras","doc":"Use both message content and logger metadata to make intelligent filtering decisions:\n\n```elixir\ndefp should_filter?(level, msg, metadata) do\n  cond do\n    level in [:error, :warning] -> false\n    routine_message?(msg) and routine_module?(metadata) -> true\n    true -> false\n  end\nend\n```","title":"2. Filter by Message Content and Metadata - Logger Filtering","ref":"logger-filtering.html#2-filter-by-message-content-and-metadata"},{"type":"extras","doc":"Apply different filtering levels based on your environment:\n- **Development**: Minimal filtering for debugging\n- **Testing**: Aggressive filtering for clean test output\n- **Production**: Balanced filtering for operational visibility","title":"3. Environment-Specific Configuration - Logger Filtering","ref":"logger-filtering.html#3-environment-specific-configuration"},{"type":"extras","doc":"Regularly review your logs to ensure:\n- Important messages aren't being filtered\n- Noise levels remain manageable\n- New components don't introduce new noise patterns","title":"4. Monitor Filter Effectiveness - Logger Filtering","ref":"logger-filtering.html#4-monitor-filter-effectiveness"},{"type":"extras","doc":"Logger filters are applied during log message processing and should be efficient:\n\n- Use pattern matching for quick message classification\n- Cache expensive computations where possible\n- Prefer string contains checks over regex for performance\n- Exit early from filter functions when possible","title":"Filter Performance - Logger Filtering","ref":"logger-filtering.html#filter-performance"},{"type":"extras","doc":"","title":"Troubleshooting - Logger Filtering","ref":"logger-filtering.html#troubleshooting"},{"type":"extras","doc":"If you're still seeing too much noise:\n1. Check that filters are properly configured\n2. Identify new noise sources and extend filters\n3. Consider adjusting log levels for specific modules","title":"Too Much Noise - Logger Filtering","ref":"logger-filtering.html#too-much-noise"},{"type":"extras","doc":"If important messages are being filtered:\n1. Review filter logic for overly broad patterns\n2. Add explicit exceptions for critical message types\n3. Test filters in development before production deployment","title":"Missing Important Messages - Logger Filtering","ref":"logger-filtering.html#missing-important-messages"},{"type":"extras","doc":"If logging performance is impacted:\n1. Profile filter functions for bottlenecks\n2. Optimize message matching patterns\n3. Consider compile-time filtering for high-volume noise","title":"Performance Issues - Logger Filtering","ref":"logger-filtering.html#performance-issues"},{"type":"extras","doc":"ExESDB's logger filtering integrates well with Phoenix telemetry and observability tools:\n\n```elixir\n# Telemetry events are not affected by logger filtering\n:telemetry.execute([:exesdb, :stream, :read], %{duration: duration}, %{\n  stream_id: stream_id,\n  event_count: length(events)\n})\n```\n\nThis ensures that your observability and monitoring systems continue to receive all necessary operational data while keeping logs clean and readable.","title":"Integration with Telemetry - Logger Filtering","ref":"logger-filtering.html#integration-with-telemetry"},{"type":"extras","doc":"ExESDB's comprehensive logger filtering system provides a clean, production-ready logging experience while maintaining full visibility into system health and errors. By layering BCUtils general-purpose filtering with ExESDB-specific filters, developers get the best of both worlds: quiet logs during normal operation and detailed diagnostics when things go wrong.\n\nThe filtering system is designed to be:\n- **Intelligent**: Preserves all errors and warnings\n- **Comprehensive**: Covers all major noise sources\n- **Configurable**: Adaptable to different environments and needs\n- **Extensible**: Easy to add custom filters for specific requirements\n- **Performant**: Minimal impact on logging performance","title":"Conclusion - Logger Filtering","ref":"logger-filtering.html#conclusion"},{"type":"extras","doc":"# How ExESDB Handles Multiple Stores\n\nThis document describes the dynamic store creation and management capabilities added to ExESDB, allowing users to create multiple event stores on-demand within a single cluster.","title":"Multiple Stores","ref":"multiple-stores.html"},{"type":"extras","doc":"Previously, ExESDB was configured with a single store ID at startup. Now, with the `ExESDB.StoreManager`, users can:\n\n- Create new stores dynamically at runtime\n- Remove stores when no longer needed\n- List and query store status and configuration\n- Use multiple stores simultaneously in the same cluster","title":"Overview - Multiple Stores","ref":"multiple-stores.html#overview"},{"type":"extras","doc":"","title":"Architecture - Multiple Stores","ref":"multiple-stores.html#architecture"},{"type":"extras","doc":"1. **ExESDB.StoreManager**: The core GenServer that manages multiple Khepri stores\n2. **ExESDBGater.API**: Updated API with store management functions\n3. **ExESDB.GatewayWorker**: Updated to handle store management operations","title":"Components - Multiple Stores","ref":"multiple-stores.html#components"},{"type":"extras","doc":"1. The `StoreManager` replaces the single `Store` process in the supervision tree\n2. Each store gets its own unique data directory under the base data directory\n3. Stores are managed independently but share the same cluster infrastructure\n4. All existing stream, subscription, and snapshot operations work with any managed store","title":"How It Works - Multiple Stores","ref":"multiple-stores.html#how-it-works"},{"type":"extras","doc":"","title":"API Reference - Multiple Stores","ref":"multiple-stores.html#api-reference"},{"type":"extras","doc":"```elixir\n# Fire-and-forget operation\n:ok = ExESDBGater.API.create_store(:my_new_store, [timeout: 15_000])\n```","title":"Creating a Store - Multiple Stores","ref":"multiple-stores.html#creating-a-store"},{"type":"extras","doc":"```elixir\n# Fire-and-forget operation\n:ok = ExESDBGater.API.remove_store(:my_store)\n```","title":"Removing a Store - Multiple Stores","ref":"multiple-stores.html#removing-a-store"},{"type":"extras","doc":"```elixir\n{:ok, stores} = ExESDBGater.API.list_stores()\n# Returns: %{store_id => %{status: :running, config: [...]}}\n```","title":"Listing Stores - Multiple Stores","ref":"multiple-stores.html#listing-stores"},{"type":"extras","doc":"```elixir\n{:ok, :running} = ExESDBGater.API.get_store_status(:my_store)\n```","title":"Getting Store Status - Multiple Stores","ref":"multiple-stores.html#getting-store-status"},{"type":"extras","doc":"```elixir\n{:ok, config} = ExESDBGater.API.get_store_config(:my_store)\n```","title":"Getting Store Configuration - Multiple Stores","ref":"multiple-stores.html#getting-store-configuration"},{"type":"extras","doc":"Once a store is created, you can use it with all existing operations:\n\n```elixir\n# Append events to a specific store\n{:ok, version} = ExESDBGater.API.append_events(:my_store, \"stream-1\", events)\n\n# Read events from a specific store\n{:ok, events} = ExESDBGater.API.get_events(:my_store, \"stream-1\", 0, 10)\n\n# List streams in a specific store\n{:ok, streams} = ExESDBGater.API.get_streams(:my_store)\n\n# Create subscriptions for a specific store\n:ok = ExESDBGater.API.save_subscription(:my_store, :by_stream, \"$all\", \"my_sub\")\n```","title":"Store Operations - Multiple Stores","ref":"multiple-stores.html#store-operations"},{"type":"extras","doc":"","title":"Configuration - Multiple Stores","ref":"multiple-stores.html#configuration"},{"type":"extras","doc":"The system still creates a default store on startup using the existing configuration:\n\n```elixir\n# In runtime.exs\nconfig :ex_esdb, :khepri,\n  data_dir: data_dir(),\n  store_id: store_id(),  # This becomes the default store\n  timeout: timeout(),\n  db_type: db_type(),\n  pub_sub: pub_sub()\n```","title":"Default Store - Multiple Stores","ref":"multiple-stores.html#default-store"},{"type":"extras","doc":"New stores inherit the default configuration but can override specific settings:\n\n```elixir\nExESDBGater.API.create_store(:custom_store, [\n  timeout: 20_000,        # Custom timeout\n  # data_dir is automatically set to base_dir/custom_store\n])\n```","title":"Dynamic Store Configuration - Multiple Stores","ref":"multiple-stores.html#dynamic-store-configuration"},{"type":"extras","doc":"Each store gets its own data directory:\n\n```\n/data/\n├── ex_esdb_store/          # Default store\n├── user_data_store/        # Custom store 1\n├── analytics_store/        # Custom store 2\n└── audit_logs_store/       # Custom store 3\n```","title":"Data Storage - Multiple Stores","ref":"multiple-stores.html#data-storage"},{"type":"extras","doc":"","title":"Use Cases - Multiple Stores","ref":"multiple-stores.html#use-cases"},{"type":"extras","doc":"Create separate stores for each tenant:\n\n```elixir\n# Create tenant-specific stores\nExESDBGater.API.create_store(:tenant_123_store)\nExESDBGater.API.create_store(:tenant_456_store)\n\n# Use tenant-specific store for operations\nExESDBGater.API.append_events(:tenant_123_store, \"orders\", events)\n```","title":"Multi-Tenant Applications - Multiple Stores","ref":"multiple-stores.html#multi-tenant-applications"},{"type":"extras","doc":"Create stores for different business domains:\n\n```elixir\n# Separate stores by domain\nExESDBGater.API.create_store(:user_management_store)\nExESDBGater.API.create_store(:order_processing_store)\nExESDBGater.API.create_store(:analytics_store)\n```","title":"Domain Separation - Multiple Stores","ref":"multiple-stores.html#domain-separation"},{"type":"extras","doc":"Create stores for different purposes:\n\n```elixir\n# Development/testing stores\nExESDBGater.API.create_store(:test_store)\nExESDBGater.API.create_store(:staging_store)\n```","title":"Environment-Specific Stores - Multiple Stores","ref":"multiple-stores.html#environment-specific-stores"},{"type":"extras","doc":"- Stores are created on the node that receives the request\n- Khepri handles replication across the cluster automatically\n- Each store maintains its own Raft consensus group\n- Store operations are distributed across cluster nodes via Swarm","title":"Cluster Behavior - Multiple Stores","ref":"multiple-stores.html#cluster-behavior"},{"type":"extras","doc":"The changes are fully backward compatible:\n\n- Existing single-store configurations continue to work\n- All existing APIs work with the default store\n- No migration is required for existing deployments","title":"Backward Compatibility - Multiple Stores","ref":"multiple-stores.html#backward-compatibility"},{"type":"extras","doc":"","title":"Best Practices - Multiple Stores","ref":"multiple-stores.html#best-practices"},{"type":"extras","doc":"Use descriptive, unique atom names:\n\n```elixir\n# Good\n:user_events_store\n:order_processing_store\n:analytics_events_store\n\n# Avoid\n:store1\n:store\n:temp\n```","title":"Store Naming - Multiple Stores","ref":"multiple-stores.html#store-naming"},{"type":"extras","doc":"- Monitor store count to avoid resource exhaustion\n- Remove unused stores to free up resources\n- Consider store lifecycle in your application design","title":"Resource Management - Multiple Stores","ref":"multiple-stores.html#resource-management"},{"type":"extras","doc":"- Use consistent timeout values for related stores\n- Plan data directory structure for backup/restore operations\n- Consider store-specific configuration needs","title":"Configuration - Multiple Stores","ref":"multiple-stores.html#configuration-1"},{"type":"extras","doc":"To monitor store health:\n\n```elixir\n# Get all stores and their status\n{:ok, stores} = ExESDBGater.API.list_stores()\n\nfor {store_id, info} <- stores do\n  IO.puts(\"Store #{store_id}: #{info.status}\")\nend\n```","title":"Monitoring - Multiple Stores","ref":"multiple-stores.html#monitoring"},{"type":"extras","doc":"Common error scenarios:\n\n```elixir\n# Store already exists\n{:error, :already_exists} = ExESDBGater.API.create_store(:existing_store)\n\n# Store not found\n{:error, :not_found} = ExESDBGater.API.get_store_status(:nonexistent_store)\n{:error, :not_found} = ExESDBGater.API.remove_store(:nonexistent_store)\n```","title":"Error Handling - Multiple Stores","ref":"multiple-stores.html#error-handling"},{"type":"extras","doc":"If you're currently using a single store and want to adopt multiple stores:\n\n1. **No immediate action required** - your existing setup continues to work\n2. **Gradual migration** - start creating new stores for new features\n3. **Optional consolidation** - consider reorganizing existing data into domain-specific stores","title":"Migration Guide - Multiple Stores","ref":"multiple-stores.html#migration-guide"},{"type":"extras","doc":"- Each store has its own Khepri cluster member\n- Memory usage scales with the number of stores\n- Network traffic increases with store count due to more Raft groups\n- Consider store count limits based on cluster capacity","title":"Performance Considerations - Multiple Stores","ref":"multiple-stores.html#performance-considerations"},{"type":"extras","doc":"- Store creation/removal should be restricted to authorized operations\n- Consider implementing store-level access controls in your application\n- Monitor store creation for unauthorized usage","title":"Security Considerations - Multiple Stores","ref":"multiple-stores.html#security-considerations"},{"type":"extras","doc":"- Store IDs must be valid Elixir atoms\n- Each store requires cluster resources (memory, network)\n- Maximum practical store count depends on cluster capacity\n- Store removal is immediate and irreversible","title":"Limitations - Multiple Stores","ref":"multiple-stores.html#limitations"},{"type":"extras","doc":"Potential future improvements:\n\n- Store templates for consistent configuration\n- Store migration utilities\n- Store-level metrics and monitoring\n- Automatic store cleanup policies\n- Store backup/restore functionality","title":"Future Enhancements - Multiple Stores","ref":"multiple-stores.html#future-enhancements"},{"type":"extras","doc":"# ExESDB - A BEAM-native Event Store\n\n`ExESDB` is a BEAM-native Event Store, built on top of the [khepri](https://github.com/rabbitmq/khepri) and [ra](https://github.com/rabbitmq/ra) subsystems.","title":"Read Me","ref":"readme.html"},{"type":"extras","doc":"One of the arguments for BEAM development is that it comes \"batteries included\". Be it caching, storage, pub/sub, observability etc... the Erlang ecosystem always has the option to avoid external dependencies.\n\nFor Event Sourcing use cases however, the Event Store is often a separate service.\n\nThis project is an attempt at addressing this point, by building further upon the work of the `rabbitmq/khepri` and `rabbitmq/ra` subsystems.","title":"Motivation - Read Me","ref":"readme.html#motivation"},{"type":"extras","doc":"ExESDB is a distributed, BEAM-native Event Store that provides high-availability event sourcing capabilities with automatic cluster formation and coordination. Built on top of Khepri and Ra (Raft consensus), it offers enterprise-grade reliability and performance.","title":"Features - Read Me","ref":"readme.html#features"},{"type":"extras","doc":"#### Event Stream Management\n- **Stream Creation**: Automatic stream creation on first event append\n- **Event Appending**: Atomic append operations with optimistic concurrency control\n- **Event Retrieval**: Query events with forward/backward traversal support\n- **Stream Versioning**: Track stream versions for conflict detection and resolution\n- **Stream Listing**: Enumerate all streams in the store\n\n#### Event Storage\n- **Persistent Storage**: Durable event storage using Khepri's distributed key-value store\n- **ACID Compliance**: Atomic, consistent, isolated, and durable operations\n- **Conflict Resolution**: Built-in optimistic concurrency control\n- **Data Integrity**: Checksum validation and corruption detection\n\n#### Subscription System\n- **Multiple Subscription Types**:\n  - `:by_stream` - Subscribe to specific event streams\n  - `:by_event_type` - Subscribe to events by type classification\n  - `:by_event_pattern` - Pattern-based event matching\n  - `:by_event_payload` - Content-based subscription filtering\n- **Persistent Subscriptions**: Durable subscriptions that survive node restarts\n- **Transient Subscriptions**: Temporary subscriptions for real-time processing\n- **Event Replay**: Start subscriptions from any stream version\n- **Acknowledgment System**: Reliable event delivery with ACK/NACK support\n- **\"Follow-the-Leader\"**: Subscription processes automatically migrate to cluster leader\n\n#### Snapshot Management\n- **Aggregate Snapshots**: Store and retrieve aggregate state snapshots\n- **Version-based Snapshots**: Snapshots tied to specific stream versions\n- **Snapshot Lifecycle**: Create, read, update, and delete snapshot operations\n- **Performance Optimization**: Reduce replay time for large aggregates\n- **Distributed Storage**: Snapshots stored across the cluster for availability","title":"Core Event Store Functionality - Read Me","ref":"readme.html#core-event-store-functionality"},{"type":"extras","doc":"#### LibCluster Integration\nExESDB uses LibCluster for automatic cluster discovery and formation:\n\n- **Strategy**: Gossip-based multicast discovery\n- **Protocol**: UDP multicast on configurable port (default: 45892)\n- **Network**: Automatic node discovery on shared networks\n- **Security**: Shared secret authentication for cluster membership\n- **Broadcast Discovery**: Configurable multicast addressing\n\n#### Cluster Formation Process\n1. **Initialization**: Node starts and initializes LibCluster topology\n2. **Discovery**: Uses gossip multicast to discover peer nodes\n3. **Authentication**: Validates cluster membership using shared secrets\n4. **Coordination**: ClusterCoordinator manages join/leave operations\n5. **Consensus**: Khepri cluster formation using Raft consensus\n6. **Monitoring**: Continuous health monitoring and leader election\n\n#### High Availability Features\n- **Automatic Clustering**: Nodes automatically discover and join clusters\n- **Split-Brain Prevention**: ClusterCoordinator prevents network partition issues\n- **Leader Election**: Automatic leader election using Raft consensus\n- **Failover**: Seamless handling of node failures\n- **Data Replication**: Events replicated across cluster nodes\n- **Consensus Protocol**: Ra/Raft ensures data consistency","title":"Distributed Architecture & Clustering - Read Me","ref":"readme.html#distributed-architecture-clustering"},{"type":"extras","doc":"#### Khepri Integration\n- **Distributed Tree Store**: Hierarchical key-value storage\n- **MVCC**: Multi-version concurrency control\n- **Transactions**: ACID transaction support\n- **Schema Evolution**: Support for data structure changes\n- **Triggers**: Event-driven data processing\n\n#### Ra (Raft) Consensus\n- **Strong Consistency**: Linearizable read/write operations\n- **Partition Tolerance**: Operates correctly during network partitions\n- **Leader-based Replication**: Single leader for write operations\n- **Log Compaction**: Automatic cleanup of old log entries\n- **Snapshot Support**: Efficient state transfer for new nodes","title":"Storage Engine - Read Me","ref":"readme.html#storage-engine"},{"type":"extras","doc":"#### Environment Configuration\n- `EX_ESDB_STORE_ID`: Unique identifier for the store instance\n- `EX_ESDB_DB_TYPE`: Deployment type (`:single` or `:cluster`)\n- `EX_ESDB_DATA_DIR`: Data directory for persistent storage\n- `EX_ESDB_TIMEOUT`: Operation timeout configuration\n- `EX_ESDB_CLUSTER_SECRET`: Shared secret for cluster authentication\n- `EX_ESDB_COOKIE`: Erlang distribution cookie\n- `EX_ESDB_PUB_SUB`: PubSub configuration for event broadcasting\n\n#### LibCluster Configuration\n```elixir\nconfig :libcluster,\n  topologies: [\n    ex_esdb_cluster: [\n      strategy: Cluster.Strategy.Gossip,\n      config: [\n        port: 45_892,\n        if_addr: \"0.0.0.0\",\n        multicast_addr: \"255.255.255.255\",\n        broadcast_only: true,\n        secret: System.get_env(\"EX_ESDB_CLUSTER_SECRET\")\n      ]\n    ]\n  ]\n```","title":"Configuration & Deployment - Read Me","ref":"readme.html#configuration-deployment"},{"type":"extras","doc":"#### High-Availability Proxy\n- **Load Balancing**: Distribute requests across gateway workers\n- **Service Discovery**: Automatic discovery of available gateway workers\n- **Fault Tolerance**: Handle worker failures gracefully\n- **Request Routing**: Smart routing based on operation type\n\n#### Worker Distribution\n- **Swarm Integration**: Distributed worker management\n- **Process Migration**: Workers can move between cluster nodes\n- **Resource Management**: Efficient resource utilization across cluster\n- **Monitoring**: Real-time worker health and performance tracking","title":"Gateway API Integration - Read Me","ref":"readme.html#gateway-api-integration"},{"type":"extras","doc":"#### Monitoring & Observability\n- **Cluster Status**: Real-time cluster membership and health\n- **Leader Tracking**: Monitor current cluster leader\n- **Performance Metrics**: Operation latency and throughput\n- **Error Tracking**: Comprehensive error logging and reporting\n- **Health Checks**: Built-in health check endpoints\n\n#### Development Tools\n- **Cluster Manager**: Interactive cluster management script\n- **Docker Compose**: Multi-node development environment\n- **Chaos Engineering**: Built-in chaos testing capabilities\n- **Validation Scripts**: Automated cluster validation tools","title":"Operational Features - Read Me","ref":"readme.html#operational-features"},{"type":"extras","doc":"```\n┌─────────────────┐    ┌─────────────────┐    ┌─────────────────┐\n│   ExESDB Node   │    │   ExESDB Node   │    │   ExESDB Node   │\n│    (Leader)     │◄──►│   (Follower)    │◄──►│   (Follower)    │\n│   Khepri + Ra   │    │   Khepri + Ra   │    │   Khepri + Ra   │\n└─────────────────┘    └─────────────────┘    └─────────────────┘\n         ▲                       ▲                       ▲\n         │                       │                       │\n         │     Gossip Multicast Network (UDP:45892)     │\n         │                       │                       │\n         ▼                       ▼                       ▼\n    Raft Consensus           Event Storage           Subscription\n     & Replication          & Retrieval             Management\n```","title":"Network Topology - Read Me","ref":"readme.html#network-topology"},{"type":"extras","doc":"#### Single Node Deployment\n- **Development**: Local development and testing\n- **Small Applications**: Simple event sourcing needs\n- **Embedded Usage**: Integration within existing applications\n\n#### Multi-Node Cluster\n- **Production**: High-availability production deployments\n- **Horizontal Scaling**: Scale read/write capacity\n- **Geographic Distribution**: Multi-region deployments\n- **Fault Tolerance**: Survive individual node failures\n\n#### Container Orchestration\n- **Docker Compose**: Development and testing environments\n- **Kubernetes**: Production container orchestration\n- **Docker Swarm**: Simplified container clustering\n- **Health Checks**: Container-level health monitoring","title":"Deployment Scenarios - Read Me","ref":"readme.html#deployment-scenarios"},{"type":"extras","doc":"#### Throughput\n- **Write Performance**: Optimized for high-volume event appending\n- **Read Performance**: Efficient event retrieval and streaming\n- **Concurrent Operations**: Handle multiple simultaneous operations\n- **Batch Processing**: Support for batch event operations\n\n#### Scalability\n- **Horizontal Scaling**: Add nodes to increase capacity\n- **Storage Scalability**: Distributed storage across cluster\n- **Subscription Scaling**: Distribute subscription load\n- **Resource Utilization**: Efficient use of available resources","title":"Performance Characteristics - Read Me","ref":"readme.html#performance-characteristics"},{"type":"extras","doc":"#### BEAM Ecosystem\n- **Phoenix Integration**: Real-time web applications\n- **LiveView Support**: Real-time UI updates\n- **GenServer Integration**: Native BEAM process integration\n- **OTP Supervision**: Fault-tolerant supervision trees\n\n#### External Systems\n- **REST APIs**: HTTP-based integration\n- **Message Queues**: Integration with external queuing systems\n- **Databases**: Projection and read model support\n- **Monitoring Systems**: Metrics and alerting integration","title":"Integration Capabilities - Read Me","ref":"readme.html#integration-capabilities"},{"type":"extras","doc":"","title":"Installation - Read Me","ref":"readme.html#installation"},{"type":"extras","doc":"ExESDB is available as a Docker image on Docker Hub with automatic versioning based on the `mix.exs` version.\n\n#### Available Tags\n- `beamcampus/ex_esdb:latest` - Latest build from master branch\n- `beamcampus/ex_esdb:0.0.18` - Specific version (current version)\n- `beamcampus/ex_esdb:0.0.x` - Any specific version tag\n\n#### Quick Start\n\n**Single Node:**\n```bash\ndocker run -d \\\n  --name ex-esdb \\\n  -p 4369:4369 \\\n  -p 9000-9100:9000-9100 \\\n  -p 45892:45892/udp \\\n  -e EX_ESDB_STORE_ID=\"my-store\" \\\n  -e EX_ESDB_DB_TYPE=\"single\" \\\n  -e EX_ESDB_DATA_DIR=\"/data\" \\\n  -v ex-esdb-data:/data \\\n  beamcampus/ex_esdb:latest\n```\n\n**Multi-Node Cluster:**\n```bash\n# Node 1 (seed node)\ndocker run -d \\\n  --name ex-esdb-node1 \\\n  --network ex-esdb-net \\\n  -p 4369:4369 \\\n  -p 9001:9000 \\\n  -p 45892:45892/udp \\\n  -e EX_ESDB_STORE_ID=\"cluster-store\" \\\n  -e EX_ESDB_DB_TYPE=\"cluster\" \\\n  -e EX_ESDB_DATA_DIR=\"/data\" \\\n  -e EX_ESDB_CLUSTER_SECRET=\"your-secret-key\" \\\n  -e EX_ESDB_COOKIE=\"your-erlang-cookie\" \\\n  -v ex-esdb-node1-data:/data \\\n  beamcampus/ex_esdb:latest\n\n# Node 2\ndocker run -d \\\n  --name ex-esdb-node2 \\\n  --network ex-esdb-net \\\n  -p 9002:9000 \\\n  -e EX_ESDB_STORE_ID=\"cluster-store\" \\\n  -e EX_ESDB_DB_TYPE=\"cluster\" \\\n  -e EX_ESDB_DATA_DIR=\"/data\" \\\n  -e EX_ESDB_CLUSTER_SECRET=\"your-secret-key\" \\\n  -e EX_ESDB_COOKIE=\"your-erlang-cookie\" \\\n  -v ex-esdb-node2-data:/data \\\n  beamcampus/ex_esdb:latest\n\n# Node 3\ndocker run -d \\\n  --name ex-esdb-node3 \\\n  --network ex-esdb-net \\\n  -p 9003:9000 \\\n  -e EX_ESDB_STORE_ID=\"cluster-store\" \\\n  -e EX_ESDB_DB_TYPE=\"cluster\" \\\n  -e EX_ESDB_DATA_DIR=\"/data\" \\\n  -e EX_ESDB_CLUSTER_SECRET=\"your-secret-key\" \\\n  -e EX_ESDB_COOKIE=\"your-erlang-cookie\" \\\n  -v ex-esdb-node3-data:/data \\\n  beamcampus/ex_esdb:latest\n```\n\n#### Docker Compose\n\nFor development and testing, use the provided Docker Compose setup:\n\n```bash\n# Clone the repository\ngit clone https://github.com/beam-campus/ex-esdb.git\ncd ex-esdb/dev-env\n\n# Start a 3-node cluster\n./start-core-only.sh\n\n# Or use the interactive cluster manager\n./ez-cluster.sh\n```\n\nThe Docker Compose setup includes:\n- **Core Cluster**: 3-node ExESDB cluster (ex-esdb0, ex-esdb1, ex-esdb2)\n- **Extended Tier**: Additional 2 nodes (ex-esdb10, ex-esdb11)\n- **Massive Tier**: Additional 8 nodes (ex-esdb20-27)\n- **Automatic Networking**: Configured Docker networks for cluster communication\n- **Data Persistence**: Named volumes for data persistence\n- **Health Checks**: Built-in container health monitoring\n\n#### Environment Variables\n\n> **📌 Important**: When using the dev-env Docker Compose configurations, you must export the `EX_ESDB_COOKIE` environment variable on your host machine. This single environment variable is used for all cluster authentication purposes (cookies, secrets, etc.).\n> \n> ```bash\n> export EX_ESDB_COOKIE=\"your-secure-cookie-value\"\n> ```\n\n| Variable | Description | Default | Required |\n|----------|-------------|---------|----------|\n| `EX_ESDB_STORE_ID` | Unique store identifier | - | Yes |\n| `EX_ESDB_DB_TYPE` | Deployment type (`single` or `cluster`) | `single` | No |\n| `EX_ESDB_DATA_DIR` | Data directory path | `/data` | No |\n| `EX_ESDB_TIMEOUT` | Operation timeout (ms) | `5000` | No |\n| `EX_ESDB_CLUSTER_SECRET` | Cluster authentication secret | - | Yes (cluster) |\n| `EX_ESDB_COOKIE` | Erlang distribution cookie | - | Yes (cluster) |\n| `EX_ESDB_PUB_SUB` | PubSub process name | `:ex_esdb_pubsub` | No |\n\n#### Ports\n\n| Port | Protocol | Description |\n|------|----------|-------------|\n| `4369` | TCP | EPMD (Erlang Port Mapper Daemon) |\n| `9000-9100` | TCP | Erlang distribution ports |\n| `45892` | UDP | LibCluster gossip multicast |\n\n#### Health Checks\n\nThe Docker image includes a built-in health check script:\n\n```bash\n# Check container health\ndocker exec ex-esdb ./check-ex-esdb.sh\n\n# View health status\ndocker inspect --format='{{.State.Health.Status}}' ex-esdb\n```\n\n#### Production Considerations\n\n1. **Security**: Use strong, unique values for `EX_ESDB_CLUSTER_SECRET` and `EX_ESDB_COOKIE`\n2. **Networking**: Ensure proper firewall rules for cluster communication\n3. **Storage**: Use named volumes or bind mounts for data persistence\n4. **Monitoring**: Implement external monitoring for cluster health\n5. **Backups**: Regular backup of data volumes\n6. **Resource Limits**: Set appropriate CPU and memory limits","title":"Docker Installation - Read Me","ref":"readme.html#docker-installation"},{"type":"extras","doc":"ExESDB is also available as a Hex package for direct integration:\n\n```elixir\ndef deps do\n  [\n    {:ex_esdb, \"~> 0.0.18\"}\n  ]\nend\n```","title":"Hex Installation - Read Me","ref":"readme.html#hex-installation"},{"type":"extras","doc":"- [Getting Started](system/guides/getting_started.md)","title":"Contents - Read Me","ref":"readme.html#contents"},{"type":"extras","doc":"- [On Hex](https://hex.pm/packages/ex_esdb)\n- [Release Documentation](https://hexdocs.pm/ex_esdb/index.html)","title":"Releases - Read Me","ref":"readme.html#releases"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.38.2"}}